;==============================================================================
;Listing 7.33 Procedura mierzaca czas trwania Tx, Ty i T
;==============================================================================

;deklaracje wejsc
#define we_x	gpio, 4
#define we_y	gpio, 5

;deklaracje rejestrow

	cblock

	t1_l, t1_h
	t2_l, t2_h
	t3_l, t3_h
	tx_l, tx_h
	ty_l, ty_h
	t_l, t_h

	endc

	clrf	t1con		; konfiguracja licznika 1, preskaler = 1, wewn. zegar


;==============================================================================
read_accel	;odczyt czasow t1, t2, t3 i obliczenia tx, ty i t

	bcf		intcon, gie			;wylacz przerwania
	bcf		t1con, tmr1on		;wylacz licznik 1

	clrf	tmr1l				;zeruj rejestry licznika 1
	clrf	tmr1h

;==============================================================================
	;pomiar t1
ed_0	;czeka na 0 na we_x
	btfsc	we_x
	goto	ed_0				;czekaj na 0

ed_1	;czeka na zbocze + na we_x
	btfsc	we_x
	goto	ed_1			;czekaj na zbocze + na we_x

	bsf	t1con, tmr1on		;jest zbocze +, zalacz licznik 1
	
ed_2	;czeka na zbocze - na we_x
	btfsc	we_x
	goto	ed_2			;czekaj na zbocze - na we_x

	bcf	t1con, tmr1on		;jest zbocze -, wylacz licznik 1

	;odczytaj t1
	movf	tmr1l, w
	movwf	t1_l
	movf	tmr1h, w
	movwf	t1_h

	bsf	t1con, tmr1on		;zalacz licznik 1

;==============================================================================
	;pomiar t2
ed_3	;czeka na zbocze + na we_y
	btfsc	we_y
	goto	ed_3			;czekaj na zbocze + na we_y

	bcf	t1con, tmr1on		;jest zbocze -, wylacz licznik 1

	;odczytaj t2
	movf	tmr1l, w
	movwf	t2_l
	movf	tmr1h, w
	movwf	t2_h

	bsf		t1con, tmr1on	;zalacz licznik 1

;==============================================================================
	;pomiar t3
ed_4	;czeka na zbocze - na we_y
	btfsc	we_y
	goto	ed_4			;czekaj na zbocze - na we_y

	bcf	t1con, tmr1on		;jest zbocze -, wylacz licznik 1

	;odczytaj t3
	movf	tmr1l, w
	movwf	t3_l
	movf	tmr1h, w
	movwf	t3_h


;==============================================================================
	;obliczenia tx, ty, t

	;t1 -> tx
	movf	t1_l, w
	movwf	tx_l
	movf	t1_h, w
	movwf	tx_h

	;korekta t2 (o czas wylaczenia licznika 1)
	movlw	.5
	addwf	t2_l, f
	skpnc
	incf	t2_h, f

	;korekta t3 (o czasy wylaczenia licznika 1)
	movlw	.10
	addwf	t3_l, f
	skpnc
	incf	t3_h, f

;==============================================================================
	;t3 -> ty
	movf	t3_l, w
	movwf	ty_l
	movf	t3_h, w
	movwf	ty_h

	;ty-t2 -> ty
	movf	t2_l, w
	subwf	ty_l, f
	skpc
	decf	ty_h, f	
	movf	t2_h, w
	subwf	ty_h, f
	
	;t3 + t2 -> t
	movf	t2_l, w
	addwf	t3_l, w
	movwf	t_l
	skpnc
	incf	t2_h, f
	movf	t2_h, w
	addwf	t3_h, w
	movwf	t_h

	;t  t1 -> t
	movf	t1_l, w
	subwf	t_l, f
	skpc
	decf	t_h, f	
	movf	t1_h, w
	subwf	t_h, f

	;t/2 ->t
	clrc
	rrf	t_h, f
	rrf	t_l, f

	bsf	intcon, gie		;zalacz przerwania


	return
