//*******************************************************************
//   Procedura obslugi wyswietlacza graficznego LPH7583
//               na ukladzie PCF8558 ver. 1.0
//	 Autor: Andrzej Niedworok
//*******************************************************************
#include <LPH7583.H>

//Funkcja wyswieta zdefiniowany w tablicy kodw znak ASCII.
void LCDChar(unsigned char d){

  i2c_write(d);
}

//Funkcja czysci ekran.
void LCDClear(void){

 unsigned char i, j;

 i2c_start();                                    //Wyslij adres wyswietlacza
 i2c_write(0x7A);				 //Ustaw kursor na pierwszej linii
 i2c_write(0x60);				 //Ustaw kursor na pierszej kolumnie
 i2c_write(0x00);
 for (i=0;i<6;i++)
  for (j=0;j<97;j++)
   i2c_write(0x00);				 //Wstaw pusty znak
 i2c_stop();
 i2c_start();
 i2c_write(0x7A);				//Wyslij adres wyswietlacza
 i2c_write(0x60);				//Ustaw kursor na pierwszej linii
 i2c_write(0x00);				//Ustaw kursor na pierszej kolumnie
}

//Funcja wyswietla zadany tekst na LCD.
void LCDWrite(unsigned char d){

 unsigned char i;

 switch(d){
//  case 'A' : LCDChar(_A);
//   break;
//  case 'B' : LCDChar(_B);
//   break;
  case 'C' : LCDChar(_C);
   break;
//  case 'D' : LCDChar(_D);
//   break;
//  case 'E' : LCDChar(_E);
//  break;
  case 'F' : LCDChar(_F);
   break;
//  case 'G' : LCDChar(_G);
//   break;
//  case 'H' : LCDChar(_H);
//   break;
  case 'I' :{
   i2c_write(0x00);
   LCDChar(_I);
   break;
  }
//  case 'J' : LCDChar(_J);
//   break;
//  case 'K' : LCDChar(_K);
//   break;
//  case 'L' : LCDChar(_L);
//   break;
//  case 'M' : LCDChar(_M);
//   break;
//  case 'N' : LCDChar(_N);
//   break;
//  case 'O' : LCDChar(_O);
//   break;
  case 'P' : LCDChar(_P);
   break;
//  case 'Q' : LCDChar(_Q);
//   break;
//  case 'R' : LCDChar(_R);
//   break;
//  case 'S' : LCDChar(_S);
//   break;
  case 'T' : LCDChar(_T);
   break;
//  case 'U' : LCDChar(_U);
//   break;
//  case 'V' : LCDChar(_V);
//   break;
//  case 'W' : LCDChar(_W);
//   break;
//  case 'X' : LCDChar(_X);
//   break;
//  case 'Y' : LCDChar(_Y);
//   break;
//  case 'Z' : LCDChar(_Z);
//   break;
  case 'a' : LCDChar(a_);
   break;
//  case 'b' : LCDChar(b_);
//   break;
//  case 'c' : LCDChar(c_);
//   break;
//  case 'd' : LCDChar(d_);
//   break;
//  case 'e' : LCDChar(e_);
//  break;
//  case 'f' : LCDChar(f_);
//   break;
//  case 'g' : LCDChar(g_);
//   break;
//  case 'h' : LCDChar(h_);
//   break;
//  case 'i' :{
//   i2c_write(0x00);
//   LCDChar(i_);
//   break;
//  }
  case 'j' : LCDChar(j_);
   break;
//  case 'k' : LCDChar(k_);
//   break;
//  case 'l' : LCDChar(l_);
//   break;
//  case 'm' : LCDChar(m_);
//   break;
//  case 'n' : LCDChar(n_);
//   break;
  case 'o' : LCDChar(o_);
   break;
//  case 'p' : LCDChar(p_);
//   break;
//  case 'q' : LCDChar(q_);
//   break;
//  case 'r' : LCDChar(r_);
//   break;
//  case 's' : LCDChar(s_);
//   break;
  case 't' : LCDChar(t_);
   break;
//  case 'u' : LCDChar(u_);
//   break;
//  case 'v' : LCDChar(v_);
//   break;
  case 'w' : LCDChar(w_);
   break;
//  case 'x' : LCDChar(x_);
//   break;
//  case 'y' : LCDChar(y_);
//   break;
//  case 'z' : LCDChar(z_);
//   break;
  case '0' : LCDChar(_0);
   break;
  case '1' :{
   i2c_write(0x00);
   LCDChar(_1);
   break;
  }
  case '2' : LCDChar(_2);
   break;
  case '3' : LCDChar(_3);
   break;
  case '4' : LCDChar(_4);
   break;
  case '5' : LCDChar(_5);
   break;
  case '6' : LCDChar(_6);
   break;
  case '7' : LCDChar(_7);
   break;
  case '8' : LCDChar(_8);
   break;
  case '9' : LCDChar(_9);
   break;
  case ' ' :{
   for (i=0;i<5;i++)
    i2c_write(0x00);
   break;
  }
//  case '.' :{
//   i2c_write(0x00);
//   i2c_write(0x60);
//   i2c_write(0x60);
//  i2c_write(0x00);
//   i2c_write(0x00);
//   break;
//  }
 }
 i2c_write(0x00);                    //Wstaw odstep pomiedzy znakami
}

//Funkcja ustawia kursor na zadanej pozycji.
void LCDGoto(unsigned char x, unsigned char y){

 i2c_start();
 i2c_write(0x7A);				//Wyslij adres wyswietlacza
 switch(y){
  case 0 : i2c_write(0x60);			//UStaw kursor na pierszym wierszu
   break;
  case 1 : i2c_write(0x61);			//Ustaw kursor na drugim wierszu
   break;
  case 2 : i2c_write(0x62);			//Ustaw kursor na trzecim wierszu
   break;
  case 3 : i2c_write(0x63);			//Ustaw kursor na czwartym wierszu
   break;
  case 4 : i2c_write(0x64);			//Ustaw kursor na piatym wierszu
   break;
 }
 i2c_write(x);				        //Ustaw kursor na zadanej kolumnie
}

//Funkcja wyswietla wskaznik postepu (bargraf).
void LCDBargraf(char x, char y, char dlugosc, char postemp){

 unsigned char i;

 LCDGoto(x, y);					//Ustaw kursor na zadanej pozycji
 LCDChar(0b01111111);				//Wyswietl poczatek paska postempu
 for (i=0;i<dlugosc;i++){
  if (i < postemp)
   LCDChar(0b01011101);			        //Wyswietl pelny pasek
  else
   LCDChar(0b01000001);  			//Wyswietl pusty pasek
 }
 LCDChar(0b01111111);				//Wyswietl koniec paska postempu
}
