Led_6 	;zapala kolejno 6 diod podlaczonych do linii GP0, GP1, GP2
		;czas zapalenia diody okresla stala czas (w sek)
		;procedura timer  odmierza czas z wykorzystaniem przerwan co 1/16 sek
		;procedura led	zapala diode o numerze przekazanym przez w (1 ... 6)
		
#define	ile_led	.6			;liczba podlaczonych diod
#define	czas	.1			;czas zapalenia led w sek
 
 
	Cblock	h'20'
	sek_16, sek, min, godz	;liczniki wewnetrzne procedury
	licz_1					;licznik czasu swiecenia diody
	nr_led					;numer zapalonej diody
	
	endc
 
 	;deklaracja typu procesora i formatu liczb

	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

	;konfiguracja procesora, fclk = 4 MHz
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_ON &_WDT_OFF
	
	org	h'00'				;adres poczatku programu
	goto	start			;skok do poczatku programu
	
	org	h'04'				;adres wektora przerwania
	goto	int				;skok do procedury obsugi przerwania


;==============================================================================
start		;pocztek programu

	;wylacz komparator
	movlw	.7
	movwf	cmcon

	;wylacz A/C
	bsf		status, rp0		;bank1
	clrf	ansel
	bcf		status, rp0		;bank0

	clrf	gpio			;zeruj gpio - inicjalizacja portow

	;konfiguracja procesora
	
	bsf	status, rp0	;bank 1
	
	movlw	b'0001000'		;poza GP3 wszystkie linie to wyjscia
	movwf	trisio
	
	movlw	b'11010111'		;t0cs =0, psa =0, preskaler = 256
	movwf	option_reg
	
	bcf		status, rp0	;bank 0
	
	clrf	sek_16			;zeruj licznik 1/16 sek
	clrf	sek				;zeruj licznik sekund
	clrf	min				;zeruj licznik minut	
	clrf	godz			;zeruj licznik godz

	movlw	czas			;wpisz czas do w 
	movwf	licz_1			;wpisz czas do licznika licz_1

	clrf	nr_led			;zeruj licznik led
	
	clrf	tmr0			;zeruj licznik 0
	
	bcf		intcon, t0if	;zeruj flage przerwania z licznika 0	
	bsf		intcon, t0ie	;odblokuj przerwania z licznika 0	
	bsf		intcon, gie		;odblokuj przerwania
	
	goto	$		;petla gowna  oczekiwanie na porzerwanie z licznika 0

	
;==============================================================================
;procedury
;==============================================================================
int			;procedura obsugi przerwania wywoywana co 1/16 s

	bcf		intcon, t0if	;zeruj flage przerwania z licznika 0

	call	timer			;wywolaj procedure timer

	call	proc_1			;wywolaj procedure proc_1 - zapala led na okreslony czas
;	call	proc_2			;wywolaj procedure proc_2
;	call	proc_3			;wywolaj procedure proc_3

	retfie


;==============================================================================
timer		;modul do obslugi licznikow czasu

	;liczniki liczace co 1/16 sek

	incf	sek_16, f		;inkrementuj licznik 1/16 sek
	movlw	.16
	subwf	sek_16, w
	btfss	status, z
	goto	timer_end
	clrf	sek_16			;zeruj licznik 1/16 sek
	;tu jestesmy co 1 sek

	;liczniki liczace co 1 sek
	
	;licznik sekund licz_1
	movf	licz_1, f		;przeczytaj licz_1
	btfss	status, z		;sprawdz czy = 0
	decf	licz_1, f		;nie, dekrementuj licz_1

	;kolejne liczniki sekund	

	incf	sek, f			;inkrementuj licznik sekund
	movlw	.60
	subwf	sek, w
	btfss	status, z
	goto	timer_end
	clrf	sek				;zeruj licznik sek
;tu jestesmy co 1 min

;liczniki liczace co 1 min

	incf	min, f			;inkrementuj licznik minut
	movlw	.60
	subwf	min, w
	btfss	status, z
	goto	timer_end
	clrf	min				;zeruj licznik min
;tu jestesmy co 1 godz

	;liczniki liczace co 1 godz

	incf	min, f			;inkrementuj licznik godzin
	movlw	.24
	subwf	godz, w
	btfss	status, z
	goto	timer_end
	clrf	godz			;zeruj licznik godz
;tu jestesmy co 24 godz

	;liczniki liczace co 24 godz

timer_end		
	return

;==============================================================================
proc_1		;zapala led na okreslony czas

	movf	licz_1, f		;odczytaj zawartosc licz_1
	btfss	status, z		;sprawdz flage zera
	return					;licz_1 > 0, nic nie zmieniaj

	;licz_1 = 0, uplynal czas, odliczaj czas na nowo, zapal kolejna diode

	movlw	czas			;czas -> w	
	movwf	licz_1			;wpisz czas do licz_1

	movf	nr_led, f		;przeczytaj numer zapalonej diody
	movlw	ile_led			;liczba podlaczonych diod
	subwf	nr_led, w		;nr_led - 6 -> w
	btfsc	status, z		;sprawdz czy wynik = 0
	clrf	nr_led			;tak, wyzeruj nr_led (liczymy tyko do 6)
	incf	nr_led, f		;zapal kolejna diode
	movf	nr_led, w		;wpisz numer zapalonej diody

	call	led				;wywolaj procedure led

	return	


;==============================================================================
;listing 7.1 	procedura zapala diode o mumerze przekazanym przez w
;==============================================================================
led			;zapala diode o mumerze przekazanym przez w

	cblock

	led_reg, temp			;rejestry pomocnicze w procedurze led

	endc

	
	andlw	b'00000111'		;ograniczenie nr diody (0  7)
	movwf	led_reg			;zapamietaj nr diody w led_reg

	bsf		status, rp0		;bank 1
	movf	trisio, w		;trisio -> w
	bcf		status, rp0		;bank 0
	iorlw	b'00000111'		;nmaska na 5 starszych bitow
	movwf	temp			;zapamietaj 5 starszych bitow w temp
	movf	led_reg	, w		;wpisz nr diody do w
	call	tris_tab		;wywolaj tris_tab (->w)
	andwf	temp, w			;wpisz nowa wartosc trisio do w
	bsf		status, rp0		;bank 1
	movwf	trisio			;konfiguruj linie	
	bcf		status, rp0		;bank 0

	movf	gpio, w			;gpio -> w
	iorlw	b'00000111'		;nmaska na 5 starszych bitow
	movwf	temp			;zapamietaj 5 starszych bitow w temp
	movf	led_reg	, w		;led_reg -> w
	call	led_tab			;wywolaj led_tab (->w)
	andwf	temp, w			;wpisz nowa wartosc gpio do w
	movwf	gpio			;zapal led

	return

tris_tab	;tablica konfiuracji linii i/o	

	addwf	pcl, f			;skok wyliczany
	retlw	b'00111111'		;gp0, gp1, gp2  wejscia, diody zgaszone
	retlw	b'00111100'		;gp0, gp1 - wyjscia, gp2  wejscie
	retlw	b'00111100'		;gp0, gp1 - wyjscia, gp2  wejscie
	retlw	b'00111010'		;gp0, gp2 - wyjscia, gp1  wejscie
	retlw	b'00111010'		;gp0, gp2 - wyjscia, gp1 - wejscie
	retlw	b'00111001'		;gp1, gp2 - wyjscia, gp0 - wejscie
	retlw	b'00111001'		;gp1, gp2 - wyjscia, gp0  wejscie 	
	retlw	b'00111111'		;gp0, gp1, gp2  wejscia, diody zgaszone

led_tab		;tablica stanu linii i/o	

	addwf	pcl, f			;skok wyliczany
	retlw	b'00111000'		;diody zgaszone
	retlw	b'00111001'		;zapal d1
	retlw	b'00111010'		;zapal d2
	retlw	b'00111001'		;zapal d3
	retlw	b'00111100'		;zapal d4
	retlw	b'00111010'		;zapal d5
	retlw	b'00111100'		;zapal d6
	retlw	b'00111000'		;diody zgaszone

	return


;==============================================================================	


	end
