;==============================================================================
;Listing 7.7 Pomiar napiecia metoda delta-sigma
;==============================================================================
pom_del_sig		;pomiar napiecia metoda delta-sigma

	cblock
	result_l, result_h		;rejestry wyniku
	cnt_l, cnt_h			;liczniki cykli komp.
	endc
	
	;inicjalizacja zmiennych
	clrf cnt_l
	clrf cnt_h
	clrf result_l
	clrf result_h
	
	movlw 	0x04 			;konfig. komp. wewn. vref, gp1- wejscie
	movwf 	cmcon			;gp2  wyjscie cyfrowe
	

del_sig_loop		;petla glowna wykonywana 1024 razy

	btfsc 	cmcon, cout 	;sprawdz stan komparatora
	goto 	laduj			;vc < vref, cykl ladowania
				;vc > vref, cykl rozladowania
	
	nop 					;opoznienie 1 cykl
	bcf 	gpio, 2 		;gp2=0, rozladowanie
	incfsz 	result_l,f 		;inkrementuj, result_l, sprawdz przepelnienie
	goto	del_2 ;			;nie ma przepelnienia
	incf 	result_h,f 		;przepelnienia, inkrementuj, result_h,
	goto 	endloop 		;

laduj		;vc < vref, cykl ladowania

	bsf		gpio, 2 		;gp2=1, ladowanie
	nop 					;opoznienie 1 cykl
	goto 	del_2 			;opoznienie 2 cykle
	
del_2						;opoznienie 2 cykle
	goto	 endloop 		;opoznienie 2 cykle


endloop		;zliczanie cykli kompensacji

	incfsz 	cnt_l,f 		;inkrementuj cnt_l
	goto	del_5 			;nie ma przepelnienia
	incf 	cnt_h, f 		;przepelnienie, inkrementuj cnt_h
	movf 	cnt_h, w 		;cnt_h ->w
	andlw 	b'00000100' 	;maska na 3 bit(4x256=1024), rozdzielczosc 10 bitow

;	andlw 	b'00001000' 	;maska na 4 bit(8x256=2048), rozdzielczosc 11 bitow
;	andlw 	b'00010000' 	;maska na 5 bit(16x256=4096), rozdzielczosc 12 bitow
;	andlw 	b'00100000' 	;maska na 6 bit(32x256=8192), rozdzielczosc 13 bitow

	btfsc 	status,z 		;sprawdzenie czy wykonano 1024 cykle kompensacji
	goto 	del_sig_loop	;nie, wykonaj kolejny cykl
	goto	exit			;tak, koniec pomiaru

del_5		;opoznienie 5 cykli
	goto 	$+1 			;2 cykle
	nop 					;1 cykl
	goto 	del_sig_loop 			;2 cykle

exit		;koniec pomiaru

	movlw 	0x03 			;konfig. komp. wewn. vref, gp1 - wejscie
	movwf 	cmcon			;gp2  wyjscie komparatora (pwm)

	return
