;i2c_test - test magistrali i2c
;zapis i odczyt danych do pamieci 24c02
;podlaczenia pamieci do procesora
;sda	gpio, 4
;scl	gpio, 5
;adres ustawiony na pamieci = 0 (a0=0, a1=0, a2=0)
;adres pamieci 24c02 = 1010
;linia wp(pin7 ukladu 24c02) zwarta do masy (zapis odblokowany)
;po zalaczeniu procesora zapisuje do komorki 0 wartosc 55h i odczytuje ja
;jezeli odczytana wartosc = 55h zapala diode podlaczona do gp2 na 65 ms



;===================================================================================
;listing 7.17 definiowanie rejestrow i oznaczen dla procedury obslugi interfejsu i2c
;===================================================================================

;i2c_def		;definicje rejestrow i oznaczen


	cblock	h'20'

	i2c_reg		
	i2c_state
	licznik	
	adr_reg
	data_reg

	endc

#define		sda	gpio, 4
#define		scl	gpio, 5

#define		led	gpio, 2

#define		ack	i2c_state, 0

#define		read	iorlw	b'00000001'		;ustawia bit r/w
#define		write	andlw	b'11111110'		;zeruje  bit r/w

#define		bank0	bcf	status, rp0
#define		bank1	bsf	status, rp0

#define		ze	status, z					;flaga z
#define		ca	status, c					;flaga c

;	return




	;deklaracja typu procesora i formatu liczb
	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

	;konfiguracja procesora
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_ON &_WDT_OFF

	org		0


	;wylacz komparator
	movlw	.7
	movwf	cmcon

	;wylacz A/C
	bsf		status, rp0	;bank1
	clrf	ansel
	bcf		status, rp0	;bank0

	movlw	b'00111000'
	movwf	gpio		;inicjalizacja portow


	;konfiguracja linii i/o
	bsf		status, rp0	;bank1
	movlw	b'00111000'
	movwf	trisio		;GP3, gp4, gp5 - wejscia, gp0, gp1, gp2 - wyjscia
	bcf		status, rp0	;bank0

	clrf	pir1
	clrf	intcon


	bsf		led			;zapal led
	call	del_64ms
	bcf		led			;zgas led
	call	del_64ms
	call	del_64ms

;	call	i2c_def			;definicje rejestrow i oznaczen	

	movlw	b'10100000'		;adres pamieci
	movwf	adr_reg


;sprawdzamy czy jest podlaczona pamiec

;warunek startu
;
;	bank1
;	bsf	sda
;	bsf	scl
;	bank0
;	
;	bsf	sda
;	bsf	scl
;
;	goto	$+1;	call	del6
;
;	bank1
;	bcf	sda
;	bcf	scl
;	bank0
;
;	bcf	sda
;	goto	$+1;	call	del6
;	bcf	scl
;	goto	$+1;	call	del6


	call	i2c_start


	movlw	b'10100001'
	movwf	i2c_reg


	call	i2c_send


	btfss	ack
	goto	wait

	bsf		led			;zapal led
	call	del_64ms
	bcf		led			;zgas led


wait

	goto	$			;czekaj tu


;========================================================================
;========================================================================
;========================================================================

;========================================================================	
del6	;opoznienie 6us

;	goto	$+1
;	goto	$+1
;	goto	$+1
	return


del_64ms	;opoznienie 64 ms
	
	clrf	t1con			;konfiguracja timera 1, presk. =1, wewn. zegar
	clrf	tmr1l			;zeruj tmr1l
	clrf	tmr1h			;zeruj tmr1h
	bcf		pir1, t1if		;zeruj  t1if
	bsf		t1con, tmr1on	;zalacz tmr1

	btfss	pir1, t1if		;sprawdz t1if
	goto	$-1				;czekajna ustawienie flagi

	bcf		t1con, tmr1on	;wylacz tmr1
	bcf		pir1, t1if		;zeruj  t1if


	return



;procedury i2c



;========================================================================
;listing 7.18 procedura inicjalizacji rejestrow portu dla linii sda i scl
;========================================================================

i2c_port_ini	;inicjalizacja rejestrow portow
	
	bank0
	bcf		sda			;przygotuj 0 na sda
	bcf		scl			;przygotuj 0 na scl
	
	bank1
	bsf		sda			;linia sda - wejscie
	bsf		scl			;linia scl - wejscie
	
	bank0
	
	return


;========================================================================
;listing 7.23 procedura start - inicjalizacja transmisji
;========================================================================

i2c_start		;wysyla sekwencje start



	bank1
	bsf	sda
	bsf	scl
	bank0
	
	bsf	sda
	bsf	scl

	goto	$+1;	call	del6

	bank1
	bcf	sda
	bcf	scl
	bank0

	bcf	sda
	goto	$+1;	call	del6
	bcf	scl
	goto	$+1;	call	del6



;	bank0
;	bcf		sda			;przygotuj 0 na sda
;	bcf		scl			;przygotuj 0 na scl
;	bank1
;	bcf		sda		;0->sda
;	
;	goto	$+1		;opoznienie
;	goto	$+1
;	goto	$+1
;	
;	bcf		scl		;0->scl
;	bank0
	
	return

;========================================================================
;listing 7.24 procedura stop - zakonczanie transmisji
;========================================================================

i2c_stop		;wysyla sekwencje stop

	bank0
	bcf		sda			;przygotuj 0 na sda
	bcf		scl			;przygotuj 0 na scl
	bank1
	bsf		scl		;wpisz 1 na scl
	bank0
	btfss	scl		;sprawdz scl
	goto	$-1		;scl=0, czekaj
	
	bank1
	bsf		sda		;1->sda
	bank0
	
	return


;========================================================================
;listing 7.25 procedura wyslania adresu lub danych
;========================================================================

i2c_send			;wysyla adres lub dane z rejestru w
		
	bank0
	movwf	i2c_reg	;wpisz dane do rejestru i2c_reg                                                                                                                                                                                                                                                                                                                                                                    
	
	movlw	.8		;liczba bitow
	movwf	licznik
	
send
	rlf	i2c_reg, f	;przesun bit do c
	bank1
	btfss	ca		;sprawdz c
	bcf		sda		;c=0, 0->sda
	btfsc	ca		;sprawdz c
	bsf		sda		;c=1, 1->sda
		
	bsf		scl		;wpisz 1 na scl                                                                                                                                                                                                                                                        
	bank0
	btfss	scl		;sprawdz scl
	goto	$-1		;scl=0, czekaj
	goto	$+1		;opoznienie
	bank1
	bcf		scl		;wpisz 0 na scl
	bank0

	decfsz 	licznik, f	;sprawdza liczbe wyslanych bitow
	goto	send	;wyslij kolejny bit
	
	goto	$+1		;opoznienie
	goto	$+1		;opoznienie
	
	bank1
	bsf		sda		;przygotowanie linii sda do odczytu
		
		;sprawdza ack
	
	bsf		scl		;wpisz 1 na scl
	bank0
	btfss	scl		;sprawdz scl
	goto	$-1		;scl=0, czekaj
		
	bank0
	bcf		ack		;zeruj ack
	btfss	sda		;czy jest potwierdzenie (sda=0)
	bsf		ack		;jest potwierdzenie, ustaw ack                                                                                                                                                                     
	bank1
	bcf		scl		;wpisz 0 na scl
	bank0
	
	return





	end

;========================================================================
;listing 7.26 procedura odbioru danych
;========================================================================

i2c_rec				;odbiera dane do rejestru i2c_reg
	;flaga porwierdzenia ack=0 wysyla potwierdzenie
	;flaga porwierdzenia ack=1 nie wysyla potwierdzenia
	
	bank1
	bsf		sda		;przygotowanie linii sda do odczytu
	
	bank0
	movlw	.8		;liczba bitow
	movwf	licznik
	
	bank1
rec			;odbiera 8 kolejnych bitow
	bsf		scl		;wpisz 1 na scl
	bank0
	btfss	scl		;sprawdz scl
	goto	$-1		;scl=0, czekaj
	
	bank0
	bsf		ca
	btfss	sda
	bcf		ca
	rlf		i2c_reg, f
	
	bank1
	bcf		scl		;wpisz 0 na scl
	bank0
	decfsz 	licznik	;sprawdza liczbe odebranych bitow
	goto	rec		;odbierz kolejny bit
	
	goto	$+1		;opoznienie
	bank1
	btfss	ack		;sprawdz ack
	bcf		sda		;wyslij potwierdzenie
	
	goto	$+1		;opoznienie
	bsf		scl		;wpisz 1 na scl
	bank0
	btfss	scl		;sprawdz scl
	goto	$-1		;scl=0, czekaj
	
	goto	$+1		;opoznienie
	
	bank1
	bcf		scl		;wpisz 0 na scl
	goto	$+1		;opoznienie
	bsf		sda		;zwolnienie linii sda 
	bank0
	
	return


;========================================================================
;listing 7.27 procedura wyslania danych do urzadzenia
;========================================================================

send_data	;wysyla dane do urzadzenia
			;adres urzadzenia w rejestrze adr_reg

	call	i2c_port_ini
	
	call 	i2c_start	;wyslij start
	movf	adr_reg, w	;wpisz adres do w
	write				;zapis do slave, zeruje bit r/w 
	
	call	i2c_send	;wyslij adres
	
	btfsc	ack			;sprawdz potwierdzenie
	goto 	send_end	;brak poptwierdzenia
						;jest potwierdzenie
	
	movf	data_reg, w	;wpisz dane do w
	call	i2c_send	;wyslij dane
	
	btfsc	ack			;sprawdz potwierdzenie
	goto 	send_end	;brak poptwierdzenia
						;jest potwierdzenie
	
	;wyslij nastepne dane
	
send_end				;koniec procedury
	call i2c_stop			;wyslij stop
	
	return
	

;========================================================================
;listing 7.27 procedura odbioru danych z urzadzenia
;========================================================================
	
read_data	;odbiera dane z urzadzenia
			;adres urzadzenia w rejestrze adr_reg
	
	call	port_ini	;inicjalizacja portow
	
	call 	start		;wyslij start
	movf	adr_reg, w	;wpisz adres do w
	read				;odczyt ze slave, ustawia bit r/w 	

	call	i2c_send	;wyslij adres
	
	btfsc	ack			;sprawdz potwierdzenie
	goto 	read _end	;brak poptwierdzenia
						;jest potwierdzenie
	
	;odbierz dane
	
	bcf		ack			;wysylaj potwierdzenie
	call	i2c_read	;odbierz dane
	
	;odbierz nastepne dane
	
	bsf		ack			;nie wysylaj potwierdzenia
	call	i2c_read	;odbierz dane
	
read_end				;koniec procedury
	call 	stop		;wyslij stop
	
	return


;========================================================================	

del_64ms	;opoznienie 64 ms
	
	clrf	t1con			;konfiguracja timera 1, presk. =1, wewn. zegar
	clrf	tmr1l			;zeruj tmr1l
	clrf	tmr1h			;zeruj tmr1h
	bcf		pir1, t1if		;zeruj  t1if
	bsf		t1con, tmr1on	;zalacz tmr1

	btfss	pir1, t1if		;sprawdz t1if
	goto	$-1				;czekajna ustawienie flagi

	bcf		t1con, tmr1on	;wylacz tmr1
	bcf		pir1, t1if		;zeruj  t1if


	return


	end





;========================================================================
;listing 7.19 zapisywanie stanow 0 albo 1 na linie sda i scl
;========================================================================

	bank1
	bcf	sda	;0 na linie sda
	bsf	sda	;1 na linie sda i przygotowanie linii sda do odczytu
	
	bcf	scl	;0 na linie scl
	bsf	scl	;1 na linie scl i przygotowanie linii scl do odczytu
	bank0


;========================================================================
;listing 7.20 procedura odczytu stanu linii sda
;========================================================================

	bank1
	bsf		sda			;przygotowanie linii sda do odczytu
	bank0
	bsf		ca			;1 -> ca
	btfss	sda			;sprawdz sda
	bcf		ca			;sda = 0, 0 -> ca
	rlf		i2c_reg, f	;wpisz bit do i2c_re


;========================================================================
;listing 7.21 procedura odczytu stanu linii scl i wykrywanie 
;stanu oczekiwania (wait state)
;========================================================================

	bank1
	bsf		scl		;wpisz 1 na scl
	bank0
	btfss	scl		;sprawdz scl
	goto	$-1		;scl=0, czekaj


;========================================================================
;listing 7.22 zapis na linie sda stanu z rejestru i2c_reg
;========================================================================

	bank0
	rlf		i2c_reg	, f	;przesun bit do flagi c
	bank1
	btfss	ca		;sprawdz c
	bcf		sda		;c=0, 0->sda
	btfsc	ca		;sprawdz c
	bsf		sda		;c=1, 1->sda
	bank0

