;PROGRAM ODLEGLOSCIOMIERZ + klawiatura 16-przyciskowa
; by KLAuS :)

	ERRORLEVEL -302
	list P=12F675
	__CONFIG _WDT_OFF & _BODEN_OFF & _MCLRE_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT 
	#include p12f675.inc
	

#define WY GPIO,2
#define SCL TRISIO,4
#define SDA TRISIO,5
#define _BANK STATUS,RP0
#define _C STATUS,0
#define _Z STATUS,2

licznik_i2c equ H'A0'
TXData equ H'A1'
licznik_znak equ H'A2'
kod_znaku equ H'A3'
wyn_MUL1 equ H'A4'
wyn_MUL2 equ H'A5'
wyn_MUL3 equ H'A6'
wyn_MUL4 equ H'A7'
BCD_1 equ H'A8'
BCD_2 equ H'A9'
BCD_3 equ H'AA'
BCD_4 equ H'AB'
TEMP1 equ H'AC'
TEMP2 equ H'AD'
licznik equ H'AE'
licznik_prostokat equ H'AF'
wait1 equ H'B0'
wait2 equ H'B1'

#define out	gpio, 1		;uzywamy GP1
#define nklaw	.16 + 1		;liczba klawiszy +1
	cblock	h'B2'	;adresy rejestrw od xxx
	div		;dzielnik
	xklaw		;nr klawisza
	endc

	org 0x0000
	goto inicjalizacja
	
	org 0x0004
	goto int	;obsluga przerwania

inicjalizacja:
;inicjalizacja procesora
	bcf		_BANK	;bank 0 (GPIO,CMCON)
	clrf	GPIO	;stan wyjsc = zero
	bsf		_BANK ;BANK 1 (TRISIO,VRCON,Option)
	movlw	b'00111111'
	movwf	trisio

	clrf	wpu
	bsf		WPU,5
	bsf		WPU,4	;PODEPNIJ PULL-UPY do lini i2c
	bcf		OPTION_REG,NOT_GPPU	;wlacz Pull-Upy
	clrf	ansel

konfig		;konfiguracja procesora
	bcf		status,rp0
	movlw	b'00010100'	;konfiguruj komparator z vref i wejsciem na gp1
	movwf	cmcon		;cinv=1
	clrf	t1con		;konfiguruj timer 1, presk1=1, clk=tcm	
	bsf		status, rp0	;bank 1
	movlw	b'10001000'	;konfiguruj vref =1/2 vdd, zalacz vref	
	movwf	vrcon
	movlw	b'00111111'	;gp0 - gp2 wejscia
	movwf	trisio

kalibr		;pomiar tm  kalibracja, wykonywany jednokrotnie
	call	roz		;rozladuj kondensator
	clrf	tmr1h
	clrf	tmr1l	;zeruj tmr1l
	call	wait4

	call	lad		;laduj kondensator
	bcf 	status,rp0
	bsf		t1con, tmr1on	;zalacz tmr1

	btfss	cmcon, cout	;sprawdz wyjscie komparatora
	goto	$-1		;czekaj na 1 na wyjsciu komparatora
	bcf		t1con,	tmr1on	;wylacz tmr1
;obliczenie dzielnika div

	bcf		status,rp0
	clrf	div
	movlw	nklaw
div_i
	incf	div, f		;inkrementuj div
	subwf	tmr1l, f	;odejmij nklaw
	btfsc	status, c	;czy roznica ujemna
	goto	div_i		;nie, skok do div_i
;korekta
	addwf	tmr1l, f
	movlw	((nklaw)/.2)	
	subwf	tmr1l, f	;odejmij nklaw/2
	btfss	status, c	;czy roznica ujemna
	decf	div, f		;korekta div

	;koniec kalibracji w rejestrze div aktualna wartosc dzielnika
loop
	clrf	temp1
	incfsz	temp1,f
	call	wait
	
	clrf	temp1
	incfsz	temp1,f
	call	wait
	
	clrf	temp1
	incfsz	temp1,f
	call	wait
	
	clrf	temp1
	incfsz	temp1,f
	call	wait

	clrf	temp1
	incfsz	temp1,f
	call	wait
	
	clrf	temp1
	incfsz	temp1,f
	call	wait

	clrf	temp1
	incfsz	temp1,f
	call	wait

pom_tx		;pomiar_tx i obliczenie xklaw, wykonywany cyklicznie

	call	roz		;rozladuj kondensator
	clrf	tmr1l	;zeruj tmr1l

	call	lad		;laduj kondensator
	bsf		t1con, tmr1on	;zalacz tmr1
	btfss	cmcon, cout	;sprawdz wyjscie komparatora
	goto	$-1		;czekaj na 1 na wyjsciu komparatora
	bcf		t1con,tmr1on	;wylacz tmr1

;obliczenie xklaw
	rrf		div, w		;div/2 -> w
	addwf	tmr1l, f	;dodaj div/2 do tmr1l ze wzgl. na zaokraglenie
	clrf	xklaw		;zeruj xklaw
	movf	div, w		;div -> w
xk_i
	incf	xklaw, f	;inkrementuj div
	subwf	tmr1l, f	;odejmij div
	btfsc	status, c	;czy roznica ujemna
	goto	xk_i		;nie, skok do xk_i
	decf	xklaw, f	;korekta xklaw
				;w rejestrze xklaw numer nacisnietego przycisku

	clrf	wyn_mul2
	movf	xklaw,w
	movwf	wyn_mul1
	call	bcd16
	movlw	h'62'
	call	linia
	call	wyswietl	
	goto 	loop

roz		;rozladowanie
	bcf		status, rp0		;bank 0
	bcf		gpio,gp1		;zeruj gp1
	bsf		status, rp0		;bank 1
	bcf		trisio,1
	bcf		status, rp0	;bank 0
	return

lad		;ladowanie
	bsf		status, rp0		;bank 1
	movlw	b'00111111'		;wcz adowanie
	movwf	trisio
	bcf		status, rp0		;bank 0
	return


	goto $


;podprocedury z przerwania :)
wait:	;czekaj chwilke
	clrf wait1
	clrf wait2
wai2:
	incfsz wait1,f
	goto wai3
	return	;koniec odczekiwania
wai3:
	incfsz wait2,f
	goto $-1
	goto wai2

MUL_16:	;mnozenie dwoch liczb 16-bitowych
	clrf wyn_MUL4	;wyczysc starsza czesc wyniku
	clrf wyn_MUL3	;wyczysc starsza czesc wyniku
	bcf _BANK	;bank 0 (TIMER)
	movf TMR1H,w
	movwf wyn_MUL2	;zawartosc TIMERA 1
	movf TMR1L,w	;przeslij do mlodszej
	movwf wyn_MUL1 	;czesci wyniku

	movlw D'17'	;LICZNIK OBIEGOW PETLI
	movwf licznik
	bcf _C	;czysc bit przeniesienia
MUL_SR: ;przesowa w prawo mnozna
	rrf wyn_MUL4,f
	rrf wyn_MUL3,f
	rrf wyn_MUL2,f
	rrf wyn_MUL1,f	
	decfsz licznik,f	;CZY koniec mnozenia?
	goto TEST_CY
	goto MUL_END	;jesli tak to koniec - RET
TEST_CY:
	btfss _C ;jesli z przesuniecia w prawo powstalo CY to wykonaj dodawanie
	goto MUL_SR	;jesli z przesuniecia w prawo nie bylo CY to przeson w prawo
MUL_SUM:
	movlw H'45'	;POCZATEK procedury DODAWANIA (DLA MNOZENIA)
	addwf wyn_MUL3,f
	btfsc _C
	incfsz wyn_MUL4,f	;przeniesienie :) (tak dziwnie jest w PICach hehe :)
	movlw H'01'	;te smieszne cyfry to wartosc 340
	addwf wyn_MUL4,f ;KONIEC DODAWANIA
	goto MUL_SR	;wykonaj przesuwanie
MUL_END:
	return	; KONIEC mnozenia
;koniec procedury mnozenia 16x16 bit

BCD16
;konwertuje liczbe BIN - wynik mnozenia (3 bajty) -
;w 3 cyfry BCD (bo mi sa tylko 3 potrzebne)
	bcf _C		;zerowanie flagi CY
	clrf BCD_1
	clrf BCD_2
	clrf BCD_3
	movlw .16
	movwf licznik	;licznik obiegow petli
BCD_Loop:
	movlw BCD_1		;adres pierwszej cyfry BCD
	movwf FSR		;do FSR - i adresowanie posrednie :)
	rlf wyn_MUL1,f	;shift BIN
	rlf wyn_MUL2,f
	rlf BCD_1,f		;into BCD
	rlf BCD_2,f
	rlf BCD_3,f
	decfsz licznik,f
	goto DAA	;korekta dziesietna po przesunieciu
	return		;koniec konwersji

DAA:
;procedura robi korekte dziesietna
	movlw .3
	movwf TEMP2	;licznik bajtow BCD do korekty 
DAA_Loop:
	movf INDF,f	;testuj czy obie cyfry BCD nie zero
	btfsc _Z	;jesli tak, to pomin korekte
	goto DAA_end
	movlw H'03'		;mlodsza tetrada
	addwf INDF,W	;korekta mlodszej tetrady
	movwf TEMP1		;zapamietaj wynik posredni
	btfsc TEMP1,3	;czy wynik > 7?
	movwf INDF		;jesli tak to korekta byla potrzebna i zapisz jako nowy wynik
	movlw H'30'		;starsza tetrada
	addwf INDF,W	;korekta starszej tetrady
	movwf TEMP1		;zapamietaj wynik posredni
	btfsc TEMP1,7	;czy wynik > 7?
	movwf INDF		;jesli tak to korekta byla potrzebna i zapisz jako wynik
DAA_end:
	incf FSR,f ;kolejna dwie tetrady BCD
	decfsz TEMP2,f
	goto DAA_Loop
	goto BCD_Loop
;koniec korekty dziesietnej

linia
	movwf	temp1
	call	START_I2C	;zainicjuj magistrale I2C
	movlw	H'7A'	;adres wyswietlacza
	movwf	TXData
	call	WYSLIJ_I2C
	movf	temp1,w	;adres wiersza
	movwf	TXData
	call	WYSLIJ_I2C
	movlw	D'27'	;adres kolumny
	movwf	TXData
	call	WYSLIJ_I2C
	return
wyswietl:
;wyswietlenie wyniku pomiaru
;zaadresowanie wyswietlacza
;	call START_I2C	;zainicjuj magistrale I2C
;	movlw H'7A'	;adres wyswietlacza
;	movwf TXData
;	call WYSLIJ_I2C
;	movlw H'61'	;adres wiersza
;	movwf TXData
;	call WYSLIJ_I2C
;	movlw D'27'	;adres kolumny
;	movwf TXData
;	call WYSLIJ_I2C

	swapf BCD_3,w	;1 cyfra wyniku
	andlw H'0F'
	movwf kod_znaku
	call wysw_znak
	
	movlw H'0F'	
	andwf BCD_3,w	;2 cyfra wyniku
	movwf kod_znaku
	call wysw_znak	

	swapf BCD_2,w	;3 cyfra wyniku
	andlw H'0F'
	movwf kod_znaku
	call wysw_znak
	
	movlw H'0F'	
	andwf BCD_2,w	;4 cyfra wyniku
	movwf kod_znaku
	call wysw_znak
	
	swapf BCD_1,w	;5 cyfra wyniku
	andlw H'0F'
	movwf kod_znaku
	call wysw_znak
	
	movlw H'0F'	
	andwf BCD_1,w	;6 cyfra wyniku
	movwf kod_znaku
	call wysw_znak
	
	call STOP_I2C
	return
;koniec wyswietlania

WYSLIJ_I2C:
;(dana do wyslania ma byc w komorce TXData
;dana jest niszczona
;uzywa komorki 'licznik_i2c'
	movlw	H'08'
	movwf	licznik_i2c	;licznik bitow do wyslania
	bcf		_BANK
	bcf		gpio,4
	bcf		gpio,5
	bsf		_BANK 		;bank 1 (TRISIO)
WW1	bcf		SCL
	rlf		TXData,f	;MSB->Cary
	bcf		SDA			;SData->low
	btfsc	_C			;wyslij jeden bit
	bsf		SDA
	bsf		SCL
	call	wait4
	bcf		SCL			;clk ->low
	decfsz	licznik_i2c,f
	goto	WW1
	bsf		SDA			;czekaj na portwierdzenie
	bsf		SCL
	call	wait4
	bcf		SCL
	bcf		SDA
	return
;koniec procedury wysylajacej bajt I2C

START_I2C:
	bcf		_BANK
	bcf		gpio,4
	bcf		gpio,5
	bsf		_BANK	;bank 1 (TRISIO)
	bsf		SDA
	bsf		SCL
	call	wait4
	bcf		SDA		;(start)
	call	wait4
	bcf		SCL		;INPUT
	call	wait4
	return
;koniec inicjalizacji lini I2C

STOP_I2C:
	bcf		_BANK
	bcf		gpio,4
	bcf		gpio,5
	bsf		_BANK	;bank 1 (TRISIO)
	bcf		SDA
	bsf		SCL
	call	wait4
	bsf 	SDA		;(stop)
	call	wait4
	bcf		SCL		;INPUT
	bcf		SDA
	return
;koniec transmisji I2C
wait4	return		;odczekaj 4us

wysw_znak: 
;wyswietla jeden znak na LCD	
;kod (0-0A) wyswietlanego znaku w komorce 'kod_znaku'
	clrf	licznik_znak	;licznik wyswietlanych kolumn
	clrf	TXData 			;jedna kolumna pusta na wyswietlaczu
	call	WYSLIJ_I2C

	rlf		kod_znaku,f		;mnozenie przez 6
	movf	kod_znaku,w
	rlf		kod_znaku,f		; - bo tyle kolumn ma jeden znak
	addwf	kod_znaku,f		; *6 = *(2+4) = *2 + *4
;	decf	kod_znaku,f
	movlw	h'01'			;ustaw strone w pamieci dla tablicy
	movwf	PCLATH			;takie cuda sa konieczne w PICach :(
wz1
	movf	licznik_znak,w	;sprawdzanie czy wyswietlono caly znak
	sublw	.6	
	btfsc	status,z		;czyli 6 kolumn z matrycy
	goto	wz2				;jesli tak to wyswietl jedna kolumne rozdzielajaca
	movf	kod_znaku,w
	addwf	licznik_znak,w
	call	maska_znak
	movwf	TXData
	call	WYSLIJ_I2C
	incf	licznik_znak,f
	goto	wz1				;wyswietlono jeden znak
wz2	clrf	TXData				;jedna kolumna pusta na wyswietlaczu
	call	WYSLIJ_I2C
	return
;koniec wysylania jednego pelnego znaku	

int:
;procedura obslugi przerwan
	bcf T1CON,TMR1ON	;wylacz timera
	retfie			;koniec przerwania
	
overflow:
;obsluga przekroczenia zakresu
	bcf PIR1,TMR1IF	;wyczysc znacznik przerwania
	movlw H'0A'		;symbol niepoprawnego wyniku
	movwf BCD_4
	movlw H'AA'		;symbol niepoprawnego wyniku
	movwf BCD_3
	call wyswietl	;wyswietl na wyswietlaczu
	bcf _BANK		;bank 0 (INTCON)
	bcf INTCON,PEIE	;zablokuj chwilowo przerwania od peryferiow
	retfie

;tablica znakow dla wyswietlacza
	org 150
maska_znak:	;'w' przed wywolaniem zawiera kod_znaku + licznik (czyli ktora kolumna)
	addwf PCL,f	;odczytaj z tablicy maske znaku
	dt H'7E',H'81',H'81',H'81',H'81',H'7E' ;maska dla '0' 
	dt H'00',H'84',H'82',H'FF',H'80',H'00' ;maska dla '1' 
	dt H'82',H'C1',H'A1',H'91',H'89',H'86' ;maska dla '2' 
	dt H'41',H'81',H'81',H'85',H'8B',H'71' ;maska dla '3' 
	dt H'30',H'28',H'24',H'22',H'FF',H'20' ;maska dla '4' 
	dt H'4F',H'89',H'89',H'89',H'89',H'71' ;maska dla '5'	 
	dt H'7C',H'8A',H'89',H'89',H'89',H'70' ;maska dla '6' 
	dt H'03',H'01',H'01',H'F1',H'09',H'07' ;maska dla '7' 
	dt H'76',H'89',H'89',H'89',H'89',H'76' ;maska dla '8' 
	dt H'0E',H'91',H'91',H'91',H'51',H'3E' ;maska dla '9' 
	dt H'80',H'80',H'80',H'80',H'80',H'80' ;maska dla 'overflow' '-'
	dt H'00',H'00',H'C0',H'C0',H'00',H'00' ;maska dla '.'
	dt H'F8',H'08',H'08',H'F0',H'08',H'F8' ;maska dla 'm'  	

napis: ;napis 'odleglosc:'
	addwf PCL,f	;odczytaj z tablicy maske znaku
	dt H'24',H'24',H'00'
	dt H'00',H'20',H'45',H'46',H'44',H'38',H'00'
	dt H'00',H'20',H'55',H'56',H'54',H'48',H'00'
	dt H'00',H'38',H'44',H'44',H'44',H'38',H'00'
	dt H'00',H'00',H'44',H'7F',H'51',H'00',H'00'
	dt H'00',H'3E',H'52',H'52',H'52',H'0C',H'00'
	dt H'00',H'18',H'54',H'54',H'54',H'38',H'00'
	dt H'00',H'00',H'40',H'7F',H'41',H'00',H'00'
	dt H'00',H'7F',H'48',H'44',H'44',H'38',H'00'
	dt H'00',H'38',H'44',H'44',H'44',H'38'

	end
