;obsluga wyswietlacza lph7583

;obsluga wyswietlacza lph7583.
	
;definicje

#define scl	trisio,4		;linia scl
#define sda	trisio,5		;linia sda

#define _c	status,c
#define _z	status,z

#define bank0	bcf	status,rp0	;definicja bank0
#define bank1	bsf	status,rp0	;definicja bank1


;deklaracje rejestrow

	cblock
	x				;wspolrzedna x na ekranie lcd
	y				;wspolrzedna y na ekranie lcd
	licznik_znak	;licznik kolumn w znaku
	kod_znaku		;umowny kod znaku do wyslania
	txdata			;rejestr nadawania
	licznik	_i2c	;licznik bitow do wyslania
	
	endc


;inicjalizacja procesora i portow
	bank0					;bank 0 (gpio,cmcon)
	clrf	gpio			;stan wyjsc = zero
	bank1					;bank 1 (trisio,vrcon,option)
	movlw	b'00111111'
	movwf	trisio

	clrf	wpu
	bsf		wpu,5
	bsf		wpu,4			;podlacz pull- upy do lini i2c
	bcf		option_reg,not_gppu	;zalacz pull-upy
	clrf	ansel			;
	bank0					;bank 0

	movlw	h'07'
	movwf	cmcon				;wylacz komparator


loop		;petla glowna programu

	;wyswietlanie 
	movlw	xxx				;wspolrzedna x (0-97)
	movwf	x
	movlw	yyy				;wspolrzedna y (h'60'- h'64')
	movwf	y	
	call	gotoxy			;przejdz do pozycji x,y

	movlw	dana1			;dana 1 do wyswietlenia 
	call	lcd				;wyswietl na lcd
	movlw	dana2			;dana 2 do wyswietlenia 
	call	lcd				;wyswietl na lcd
	...		;nastepne dane
	call	stop_i2c			;wyslij stop
	....

	....	;podaj nowe wspolrzedne xy
	call	gotoxy
	....	;podaj nowe dane do wyswietlenia
	call	lcd
	...		;nastepne dane
	call	stop_i2c

	;reszta programu glownego

	goto	loop			;idz do petli

;procedury

gotoxy		;ustaw pozycje kursora na wyswietlaczu lcd

	call	start_i2c		;zainicjuj magistrale i2c
	movlw	h'7a'			;adres wyswietlacza
	call	wyslij_i2c
	movf	y, w
	call	wyslij_i2c		;pozycja y na wyswietlaczu
	movf	x, w
	call	wyslij_i2c		;pozycja x na wyswietlaczu
	return


lcd		;wyswietla jeden znak na lcd	

		;kod (0h-0dh) wyswietlanego znaku w rejestrze w
		;uzywa zmiennych 'licznik_znak' 'kod_znaku'

	movwf	kod_znaku		;zapamietaj wysylany znak
	clrf	licznik_znak	;licznik kolumn
	movf	kod_znaku,w
	rlf		kod_znaku,f		;mnozenie przez 5
	rlf		kod_znaku,f		; - bo tyle kolumn ma jeden znak
	addwf	kod_znaku,f		; *5 = *4 + *1
	movlw   high maska_znak	;oblicz wartosc pclath dla tablicy
	movwf   pclath			;wpisz do pclath

wz1
	movf	licznik_znak,w	;sprawdzanie czy wyswietlono caly znak
	sublw	.5	
	btfsc	_z				;czyli 6 kolumn z matrycy
	goto	wz2				;jesli tak, to wyswietl jedna kolumne rozdzielajaca
	movf	kod_znaku,w
	addwf	licznik_znak,w
	call	maska_znak		;zwraca kolejne kolumny znaku
	movwf	txdata
	call	wyslij_i2c
	incf	licznik_znak,f
	goto	wz1				;wyswietlono jeden znak
wz2	
	clrf	txdata			;jedna kolumna pusta na wyswietlaczu
	call	wyslij_i2c

	return					;koniec wysylania jednego pelnego znaku


wyslij_i2c
	;dana do wyslania powinna byc w rejestrze w
	;procedura uzywa komorki 'licznik_i2c' oraz txdata

	movwf	txdata			;zapamietaj dana do wyslania
	movlw	h'08'
	movwf	licznik_i2c		;licznik bitow do wyslania

	bank0	
	bcf		scl			;przygotuj 0 -> scl	
	bcf		sda			;przygotuj 0 -> sda	
	bank1		

ww1	
	bcf		scl			;wyslij 0 -> scl
	rlf		txdata,f	;msb->cary
	bcf		sda			;ustaw 0 na sda
	btfsc	_c			;czy bit byl = 0
	bsf		sda			;nie, ustaw 1 na sda
	bsf		scl			;wyslij 1 -> scl
	call	wait4		;czekaj 4 us
	bcf		scl			;wyslij 0 -> scl
	decfsz	licznik_i2c,f
	goto	ww1			;wyslij kolejny bit

	bsf		sda			;bit portwierdzenia
	bsf		scl			;wyslij 1 -> scl
	call	wait4		;czekaj 4 us
	bcf		scl			;wyslij 0 -> scl
	bcf		sda			;wyslij 0 -> sda

	return			;koniec procedury wysylajacej bajt i2c


start_i2c	;wysyla warunek startu

	bank0	
	bcf		scl			;przygotuj 0 -> scl	
	bcf		sda			;przygotuj 0 -> sda	
	bank1		
	bsf		sda			;wyslij 1 -> sda
	bsf		scl			;wyslij 1 -> scl	;stan poczatkowy na liniach sda i scl
	call	wait4		;czekaj 4 us
	bcf		sda			;wyslij 0 -> sda	;warunek startu	
	call	wait4		;czekaj 4 us
	bcf		scl			;wyslij 0 -> scl		
	call	wait4		;czekaj 4 us

	return		;koniec inicjalizacji lini i2c


stop_i2c		;wysyla warunek stopu

	bank0	
	bcf		scl			;przygotuj 0 -> scl	
	bcf		sda			;przygotuj 0 -> sda	
	bank1		
	bcf		sda			;wyslij 0 -> sda
	bsf		scl			;wyslij 1 -> scl, stan poczatkowy na liniach sda i scl
	call	wait4		;czekaj 4 us
	bsf 	sda			;wyslij 1 -> scl	;warunek stopu
	call	wait4		;czekaj 4 us

	return		;koniec transmisji i2c

wait4			;opoznienie 4us
	return	


	org 200		;umiescic na poczatku paragrafu (org 200, 300, 400 itp)
				;kod_znaku * 5 w rejestrze w

maska_znak		;tablica znakow dla wyswietlacza 
	addwf pcl,f	;odczytaj z tablicy maske znaku
	dt h'3e',h'51',h'49',h'45',h'3e' 	;maska dla '0'  - kod 0
	dt h'00',h'42',h'7f',h'40',h'00' 	;maska dla '1'  - kod 1
	dt h'42',h'61',h'51',h'49',h'46' 	;maska dla '2'  - kod 2
	dt h'21',h'41',h'45',h'4b',h'31' 	;maska dla '3'  - kod 3
	dt h'18',h'14',h'12',h'7f',h'10' 	;maska dla '4'  - kod 4 
	dt h'27',h'45',h'45',h'45',h'39' 	;maska dla '5'  - kod 5	 
	dt h'3c',h'4a',h'49',h'49',h'30' 	;maska dla '6'  - kod 6 
	dt h'03',h'01',h'71',h'09',h'07' 	;maska dla '7'  - kod 7 
	dt h'36',h'49',h'49',h'49',h'36' 	;maska dla '8'  - kod 8 
	dt h'06',h'49',h'49',h'29',h'1e' 	;maska dla '9'  - kod 9 
	dt h'00',h'00',h'00',h'00',h'00' 	;maska dla ' '  - kod ah
	dt h'08',h'08',h'08',h'08',h'08' 	;maska dla '-'  - kod bh
	dt h'00',h'00',h'c0',h'c0',h'00' 	;maska dla '.'  - kod ch
	dt h'7c',h'04',h'18',h'04',h'78' 	;maska dla 'm'  - kod dh  	
	; tutaj maski dla kolejnych znakow

