;Program test_rs - nadaje bajt, ktory odebral (nie ma bufora na odebrane dane)

;	GP5 - linia out - (wyjscie TX RS232)
;	GP4 - linia in - (wejscie TX RS232)


#define out 	gpio, 5		;deklaracja linii out (GP5)		
#define in 		gpio, 4		;deklaracja linii in  (GP4)	
	

#define baud	.2400		;deklaracja szybkosci transmisji w bitach/sek
	
;==============================================================================
;wartosci stalych ntb i ptb dla roznych szybkosci transmisji 
;najblizsza wartosc dla Fclk = 4.000 MHz
;uwaga - nalezy skalibrowac wewnetrzny oscylator
;ntb = (((fclk/4)/baud)-13)/3, fclk w Hz, baud w bitach/sek

	;TABELA ntb i ptb (wartosci dziesietne)

	; 2400 bit/sek - ntb = .134 lub .135	ptb = .66
	; 4800 bit/sek - ntb = .65 				ptb = .31
	; 9600 bit/sek - ntb = .30 lub .31		ptb = .14
	;19200 bit/sek - ntb = .13				ptb =  .5
	;38400 bit/sek - ntbt = .4				ptb =  .1


	if	baud == .2400		;szybkosc 2400 bit/sek
	#define	ntb	.134		;stala do odmierzania czasu trwania 1 bitu 
	#define	ptb	.66			;stala do odmierzania czasu trwania 1/2 bitu 
	endif

	if	baud == .4800		;szybkosc 4800 bit/sek
	#define	ntb	.65			;stala do odmierzania czasu trwania 1 bitu 
	#define	ptb	.31			;stala do odmierzania czasu trwania 1/2 bitu 
	endif

	if	baud == .9600		;szybkosc 9600 bit/sek
	#define	ntb	.30			;stala do odmierzania czasu trwania 1 bitu 
	#define	ptb	.14			;stala do odmierzania czasu trwania 1/2 bitu 
	endif

	if	baud == .19200		;szybkosc 19200 bit/sek
	#define	ntb	.13			;stala do odmierzania czasu trwania 1 bitu 
	#define	ptb	.5			;stala do odmierzania czasu trwania 1/2 bitu 
	endif

	if	baud == .38400		;szybkosc 38400 bit/sek
	#define	ntb	.4			;stala do odmierzania czasu trwania 1 bitu 
	#define	ptb	.1			;stala do odmierzania czasu trwania 1/2 bitu 
	endif

	ifndef	ntb
	error	"Zla szybkosc transmisji"
	endif

;==============================================================================

	cblock	h'20'			;deklaracje adresow rejestrow

	tx_reg, rx_reg			;rejestr szeregowy nadajnika i odbiornika rs
	cnt						;licznik bitow
	del_reg					;licznik opoznienia
	flag_reg				;rejestr flag

	endc

#define rx_err		flag_reg, 1		;flaga rx_err


 	;deklaracja typu procesora i formatu liczb

	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

	;konfiguracja procesora, fclk = 4 MHz
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_ON &_WDT_OFF

	errorlevel -302			;nie wyprowadzaj komunikatu nr 302
	
	org	h'00'				;adres poczatku programu
	goto	start			;skok do poczatku programu


;==============================================================================	
start		;pocztek programu

	;konfiguracja procesora

	;wylacz komparator
	movlw	.7				;wylacz komparator
	movwf	cmcon			;cinv=1

	;wylacz A/C
	bsf		status, rp0		;bank1
	clrf	ansel

	;fabryczna kalibracja oscylatora
	call	h'3ff'			;fabryczna wartosc kalibracyjna -> w
	movwf	osccal			;w -> osccal
	bcf		status, rp0		;bank0

	movlw	b'00110000'		;inicjalizacja linii portu
	movwf	gpio

	bsf	status, rp0			;bank 1

	;konfiguracja linii procesora
	movlw	b'00011000'		;wejscia GP3 i GP4,  reszta to wyjscia
	movwf	trisio

	bcf		status, rp0		;bank 0

	;konfiguracja licznika 1
	movlw	b'00110000'		;preskaler = 8, wewn. zegar 
	movwf	t1con

	clrf	tmr1h			;zeruj rejestr tmr1h
	clrf	tmr1l			;zeruj rejestr tmr1l

	clrf	intcon			;zablokuj przerwania
	clrf	pir1			;zeruj flagi - t1if

	bsf		t1con, tmr1on	;zalacz timer 1

	clrf	flag_reg		;zeruj rejestr flag


;==============================================================================
loop		;petla glowna

	call	rx_in	 		;odbierz 1 bajt

	btfss	rx_err			;sprawdz flage bledu
	call	tx_out			;nie bylo bledu, wyslij to co odebrales
							;blad, odbierz kolejny bajt
	goto	loop			;powrot do petli


;==============================================================================
;procedury
;==============================================================================


;==============================================================================
tx_out		;wysyla bit startu, 8 bitow danych i bit stopu

	movwf	tx_reg			;wpisz dane do rejestru tx_reg

	movlw	.9
	movwf	cnt				;licznik bitow (1+8)

	bcf	status, c			;wpisz bit startu

tx_loop		;petla do nadwania bitow
	
	btfss	status, c		;sprawdz c
	bcf		out				;c=0, zeruj out
	btfsc	status, c		;sprawdz c
	bsf		out				;c=1, ustaw out

	call	del_ntb			;opoznienie na czas 1 bitu
	
	rrf		tx_reg, f		;przesun do c kolejny bit

	decfsz	cnt, f			;sprawdz czy nadano wszystkie bity
	goto	tx_loop			;nie, nadawaj kolejny bit

	bsf	status, c			;wpisz bit stopu

	btfss	status, c		;sprawdz c
	bcf		out				;c=0, zeruj out
	btfsc	status, c		;sprawdz c
	bsf		out				;c=1, ustaw out

	goto	$+1				;opoznienie wyrownawcze
	goto	$+1				;opoznienie wyrownawcze
	call	del_ntb			;opoznienie na czas 1 bitu, nadaje pierwszy bit stopu

;	drugi bit stopu
;	goto	$+1				;opoznienie wyrownawcze
;	goto	$+1				;opoznienie wyrownawcze
;	goto	$+1				;opoznienie wyrownawcze
;	call	del_ntb			;opoznienie na czas 1 bitu, nadaje drugi bit stopu

	return


;==============================================================================
del_ntb		;odmierza opoznienie na czas trwania 1 bitu

	movlw	ntb				;stala do odmierzania czasu 1 bitu	
	movwf	del_reg			;wpisz wartosc poczatkowa do licznika 

	decfsz	del_reg, f		;sprawdz czy del_reg =0 (petla do odliczania opoznienia)
	goto	$-1				;nie, czekaj dalej	

	return


;==============================================================================
rx_in		;procedura odbioru ramki 8n1

	bcf	rx_err				;zeruj flage bledu

	movlw	.8				;liczba bitow danych
	movwf	cnt				;inicjuj licznik bitow
	
;	goto	$+1				;zamiast 2 nastepnych linii
	btfsc	in				;sprawdz linie in
	goto	$-1				;czekaj na bit startu

	call 	del_ptb			;opoznienie 0.5 tb

;	goto	$+1				;zamiast 2 nastepnych linii
	btfsc	in				;sprawdz bit startu po czasie 0.5 tb
	goto	rx_end			;pomin odbior ramki

	call 	del_ptb			;opoznienie 0.5 tb
	nop						;dodatkowe opoznienie

rx_loop		;odbior kolejnych bitow

	call 	del_ptb			;opoznienie 0.5 tb

	bcf		status, c		;zeruj c
	btfsc	in				;sprawdz linie in
	bsf		status, c		;ustaw c
	rrf		rx_reg, f		;przesun c do rejestru rx_reg

	call 	del_ptb			;opoznienie 0.5 tb

	decfsz	cnt, f			;czy odebrano wszystkie bity
	goto	rx_loop			;kolejny bit danych

	call 	del_ptb			;opoznienie 0.5 tb
	call 	del_ptb			;opoznienie 0.5 tb

	btfss	in				;sprawdz bit stopu
	bsf 	rx_err			;brak, ustaw flage bledu

	movf	rx_reg, w		;zapisz dane do w


rx_end		;koniec procedury rx_in

	return			


;==============================================================================
del_ptb		;odmierza opoznienie na czas trwania 1/2 bitu

	movlw	ptb				;stala do odmierzania czasu 1/2 bitu	
	movwf	del_reg			;wpisz wartosc poczatkowa do licznika 
	goto	$+1				;dodatkowe opoznienie

	decfsz	del_reg, f		;sprawdz czy del_reg =0 (petla do odliczania opoznienia)
	goto	$-1				;nie, czekaj dalej
	
	return

;==============================================================================

	end
