;PROGRAM ODLEGLOSCIOMIERZ
; by KLAuS :)

	ERRORLEVEL -302
	list P=12F629
	__CONFIG _WDT_OFF & _BODEN_OFF & _MCLRE_OFF & _PWRTE_ON & _INTRC_OSC_CLKOUT 
	#include p12f629.inc
	

#define WY GPIO,2
#define SCL TRISIO,0	;org=4
#define SDA TRISIO,5
#define _BANK STATUS,RP0
#define _C STATUS,0
#define _Z STATUS,2

licznik_i2c equ H'A0'
TXData equ H'A1'
licznik_znak equ H'A2'
kod_znaku equ H'A3'
wyn_MUL1 equ H'A4'
wyn_MUL2 equ H'A5'
wyn_MUL3 equ H'A6'
wyn_MUL4 equ H'A7'
BCD_1 equ H'A8'
BCD_2 equ H'A9'
BCD_3 equ H'AA'
BCD_4 equ H'AB'
TEMP1 equ H'AC'
TEMP2 equ H'AD'
licznik equ H'AE'
licznik_prostokat equ H'AF'
wait1 equ H'B0'
wait2 equ H'B1'

	org 0x0000
	goto inicjalizacja
	
	org 0x0004
	goto int	;obsluga przerwania

inicjalizacja:
;inicjalizacja procka
	bcf _BANK	;bank 0 (GPIO,CMCON)
	clrf GPIO	;stan wyjsc =zero
	movlw B'00010100'
	movwf CMCON	;tryb pracy komparatora

	bsf _BANK ;BANK 1 (TRISIO,VRCON,Option)
	clrf TRISIO	;wszytkie linie jako wyjscie
	bsf TRISIO,1	;wejscie komparatora jako wejscie :)
	movlw B'10101110'
	movwf VRCON	;Uref dla komparatora = 13/24 *Vdd
	bsf WPU,5
	bsf WPU,4	;PODEPNIJ PULL-UPY do lini i2c
	bcf OPTION_REG,NOT_GPPU	;wlacz Pull-Upy

	bsf PIE1,CMIE	;COMP interupt enable
	bsf PIE1,TMR1IE	;TIMER1 interupt enable	
;koniec inicjalizacji procesora.

;teraz wyslanie na wyswietlacz napisu 'odleglosc'
	call START_I2C	;zainicjuj magistrale I2C
	movlw H'7A'	;adres wyswietlacza
	movwf TXData
	call WYSLIJ_I2C
	movlw H'60'	;adres wiersza
	movwf TXData
	call WYSLIJ_I2C
	movlw D'14'	;adres kolumny
	movwf TXData
	call WYSLIJ_I2C
;wyswietlenie napisu :P
	movlw D'64'			;licznik wyswietlanych kolumn
	movwf licznik_znak
	movlw H'01'			;ustaw strone w pamieci dla tablicy
	movwf PCLATH		;takie cuda sa konieczne w PICach :(
nap1:
	movf licznik_znak,w
	call napis
	movwf TXData
	call WYSLIJ_I2C
	decfsz licznik_znak,f
	goto nap1			;koniec wysylania napisu
	call STOP_I2C

start:
	bcf _BANK		;bank 0 (T1CON)
	clrf T1CON		;inicjalizacja TIMERA
	clrf TMR1L		;czyszczenie zawartosci
	clrf TMR1H		;timera 1

;generacja prostokata :)
;wykonuje sie 10 razy, pozniej czeka na nastepny pomiar i zaczyna od start
	movlw .15
	movwf licznik_prostokat
	bsf T1CON,TMR1ON	;wlacz timera
	bsf _BANK	;bank 1 (TRISIO)
PROSTOKAT:
	bsf WY	;USTAW wyjscie=1
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	bcf WY	;USTAW wyjscie=0
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	decfsz licznik_prostokat,f
	goto PROSTOKAT

;czekaj chwilke az wygasnie wlasne echo
	movlw .1
	movwf wait1
	incfsz wait1,f
	goto $-1
;koniec odczekiwania

;teraz wlacz przerwania i czekaj na echo odebrane	
	bcf _BANK 			;bank 0 (PIR1)
	clrf PIR1			;wyczysc znaczniki przerwania
	movlw B'11000000'
	movwf INTCON		;wlacz przerwania globalne i od peryferiow
	;jesli odbierze echo to sie wlaczy przerwanie :)

;odczekaj ok. 0.5 sekundy na nastepny pomiar		
	call wait
	call wait
	goto start
;koniec glownej petli. reszta wywolywana zgodnie z potrzebami jako



;podprocedury z przerwania :)
wait:	;czekaj chwilke
	clrf wait1
	clrf wait2
wai2:
	incfsz wait1,f
	goto wai3
	return	;koniec odczekiwania
wai3:
	incfsz wait2,f
	goto $-1
	goto wai2

MUL_16:	;mnozenie dwoch liczb 16-bitowych
	clrf wyn_MUL4	;wyczysc starsza czesc wyniku
	clrf wyn_MUL3	;wyczysc starsza czesc wyniku
	bcf _BANK	;bank 0 (TIMER)
	movf TMR1H,w
	movwf wyn_MUL2	;zawartosc TIMERA 1
	movf TMR1L,w	;przeslij do mlodszej
	movwf wyn_MUL1 	;czesci wyniku

	movlw D'17'	;LICZNIK OBIEGOW PETLI
	movwf licznik
	bcf _C	;czysc bit przeniesienia
MUL_SR: ;przesowa w prawo mnozna
	rrf wyn_MUL4,f
	rrf wyn_MUL3,f
	rrf wyn_MUL2,f
	rrf wyn_MUL1,f	
	decfsz licznik,f	;CZY koniec mnozenia?
	goto TEST_CY
	goto MUL_END	;jesli tak to koniec - RET
TEST_CY:
	btfss _C ;jesli z przesuniecia w prawo powstalo CY to wykonaj dodawanie
	goto MUL_SR	;jesli z przesuniecia w prawo nie bylo CY to przeson w prawo
MUL_SUM:
	movlw H'45'	;POCZATEK procedury DODAWANIA (DLA MNOZENIA)
	addwf wyn_MUL3,f
	btfsc _C
	incfsz wyn_MUL4,f	;przeniesienie :) (tak dziwnie jest w PICach hehe :)
	movlw H'01'	;te smieszne cyfry to wartosc 340
	addwf wyn_MUL4,f ;KONIEC DODAWANIA
	goto MUL_SR	;wykonaj przesuwanie
MUL_END:
	return	; KONIEC mnozenia
;koniec procedury mnozenia 16x16 bit

BIN_2_BCD:
;konwertuje liczbe BIN - wynik mnozenia (3 bajty) -
;w 3 cyfry BCD (bo mi sa tylko 3 potrzebne)
	bcf _C		;zerowanie flagi CY
	clrf BCD_1
	clrf BCD_2
	clrf BCD_3
	clrf BCD_4
	movlw .24
	movwf licznik	;licznik obiegow petli
BCD_Loop:
	movlw BCD_1		;adres pierwszej cyfry BCD
	movwf FSR		;do FSR - i adresowanie posrednie :)
	rlf wyn_MUL1,f	;shift BIN
	rlf wyn_MUL2,f
	rlf wyn_MUL3,f
	rlf BCD_1,f		;into BCD
	rlf BCD_2,f
	rlf BCD_3,f
	rlf BCD_4,f
	decfsz licznik,f
	goto DAA	;korekta dziesietna po przesunieciu
	return		;koniec konwersji

DAA:
;procedura robi korekte dziesietna
	movlw .3
	movwf TEMP2	;licznik bajtow BCD do korekty 
DAA_Loop:
	movf INDF,f	;testuj czy obie cyfry BCD nie zero
	btfsc _Z	;jesli tak, to pomin korekte
	goto DAA_end
	movlw H'03'		;mlodsza tetrada
	addwf INDF,W	;korekta mlodszej tetrady
	movwf TEMP1		;zapamietaj wynik posredni
	btfsc TEMP1,3	;czy wynik > 7?
	movwf INDF		;jesli tak to korekta byla potrzebna i zapisz jako nowy wynik
	movlw H'30'		;starsza tetrada
	addwf INDF,W	;korekta starszej tetrady
	movwf TEMP1		;zapamietaj wynik posredni
	btfsc TEMP1,7	;czy wynik > 7?
	movwf INDF		;jesli tak to korekta byla potrzebna i zapisz jako wynik
DAA_end:
	incf FSR,f ;kolejna dwie tetrady BCD
	decfsz TEMP2,f
	goto DAA_Loop
	goto BCD_Loop
;koniec korekty dziesietnej

wyswietl:
;wyswietlenie wyniku pomiaru
;zaadresowanie wyswietlacza
	call START_I2C	;zainicjuj magistrale I2C
	movlw H'7A'	;adres wyswietlacza
	movwf TXData
	call WYSLIJ_I2C
	movlw H'62'	;adres wiersza
	movwf TXData
	call WYSLIJ_I2C
	movlw D'27'	;adres kolumny
	movwf TXData
	call WYSLIJ_I2C

	movlw H'0F'	
	andwf BCD_4,w	;najstarsza cyfra wyniku
	movwf kod_znaku
	call wysw_znak

;wyswietlenie kropki dziesietnej
	clrf TXData
	call WYSLIJ_I2C
	movlw H'C0'
	movwf TXData
	call WYSLIJ_I2C
	movlw H'C0'
	movwf TXData
	call WYSLIJ_I2C
	clrf TXData
	call WYSLIJ_I2C
;koniec wyswietlania kropki

	swapf BCD_3,w	;mlodsza cyfra wyniku
	andlw H'0F'
	movwf kod_znaku
	call wysw_znak
	
	movlw H'0F'	
	andwf BCD_3,w	;najmlodsza cyfra wyniku
	movwf kod_znaku
	call wysw_znak
	
	movlw H'00'		;symbol metra
	movwf TXData
	call WYSLIJ_I2C
	movlw H'F0'
	movwf TXData
	call WYSLIJ_I2C
	movlw H'08'
	movwf TXData
	call WYSLIJ_I2C
	movlw H'08'
	movwf TXData
	call WYSLIJ_I2C
	movlw H'F0'
	movwf TXData
	call WYSLIJ_I2C
	movlw H'08'
	movwf TXData
	call WYSLIJ_I2C
	movlw H'08'
	movwf TXData
	call WYSLIJ_I2C
	movlw H'F0'
	movwf TXData
	call WYSLIJ_I2C

	call STOP_I2C
	return
;koniec wyswietlania

WYSLIJ_I2C:
;(dana do wyslania ma byc w komorce TXData
;dana jest zniszczona
;uzywa komorki 'licznik_i2c'
	movlw H'08'
	movwf licznik_i2c	;licznik bitow do wyslania
	bsf _BANK 		;bank 1 (TRISIO)
WW1:
	bcf SCL
	rlf TXData,f	;MSB->Cary
	bcf SDA			;SData->low
	btfsc _C		;wyslij jeden bit
	bsf SDA
	bsf SCL
	nop
;;	nop
;;	nop
;;	nop
;;	nop
;;	nop
	bcf SCL			;clk ->low
	nop
	decfsz licznik_i2c,f
	goto WW1
	bsf SDA			;czekaj na portwierdzenie
	bsf SCL
	nop
;;	nop
;;	nop
;;	nop
;;	nop
	bcf SCL
	bcf SDA
	return
;koniec procedury wysylajacej bajt I2C

START_I2C:
	bsf _BANK	;bank 1 (TRISIO)
	bsf SDA
	bsf SCL
;;	nop
;;	nop
;;	nop
;;	nop
	nop
	bcf SDA		;(start)
	nop
;;	nop
;;	nop
;;	nop
;;	nop
	bcf SCL		;INPUT
;;	nop
;;	nop
;;	nop
	nop
	return
;koniec inicjalizacji lini I2C

STOP_I2C:
	bsf _BANK	;bank 1 (TRISIO)
	bcf SDA
	bsf SCL
;;	nop
;;	nop
;;	nop
;;	nop
	nop
	bsf SDA	;(stop)
	nop
;;	nop
;;	nop
;;	nop
;;	nop
	bcf SCL	;INPUT
	return
;koniec transmisji I2C

wysw_znak: 
;wyswietla jeden znak na LCD	
;kod (0-9) wyswietlanego znaku w kod_znaku
	movlw H'06'			;licznik wyswietlanych kolumn
	movwf licznik_znak
	clrf TXData 		;jedna kolumna pusta na wyswietlaczu
	call WYSLIJ_I2C

	rlf kod_znaku,f		;mnozenie przez 6
	movf kod_znaku,w	;
	rlf kod_znaku,f		; - bo tyle kolumn ma znak
	addwf kod_znaku,f	; *6 = *(2+4) = *2 + *4
	decf kod_znaku,f
	movlw H'01'			;ustaw strone w pamieci dla tablicy
	movwf PCLATH		;takie cuda sa konieczne w PICach :(
wz1:
	movf kod_znaku,w
	addwf licznik_znak,w
	call maska_znak
	movwf TXData
	call WYSLIJ_I2C
	decfsz licznik_znak,f
	goto wz1			;wyswietlono jeden znak
	movlw H'00'	;jedna kolumna pusta na wyswietlaczu
	movwf TXData
	call WYSLIJ_I2C
	return
;koniec wysylania jednego pelnego znaku	

int:
;procedura obslugi przerwan
	bcf T1CON,TMR1ON	;wylacz timera
	btfsc PIR1,TMR1IF	;czy przerwanie od timera?
	goto overflow		;przekroczenie zakresu :(

	bcf PIR1,CMIF		;w takim razie przerwanie bylo od komparatora :)
	call MUL_16			;przetworz wynik pomiaru

	;podziel wynik przez dwa
	;bo mierzymy odleglosc tylko w jedna strone
	bcf _C
	rrf wyn_MUL4,f
	rrf wyn_MUL3,f
	rrf wyn_MUL2,f
	rrf wyn_MUL1,f	

	;teraz zamien wynik w postac BCD
	call BIN_2_BCD	;wynik do postaci 'czytelnej'
	call wyswietl	;wyswietl na wyswietlaczu
	bcf INTCON,PEIE	;zablokuj chwilowo przerwania od peryferiow
	retfie			;koniec przerwania
	
overflow:
;obsluga przekroczenia zakresu
	bcf PIR1,TMR1IF	;wyczysc znacznik przerwania
	movlw H'0A'		;symbol niepoprawnego wyniku
	movwf BCD_4
	movlw H'AA'		;symbol niepoprawnego wyniku
	movwf BCD_3
	call wyswietl	;wyswietl na wyswietlaczu
	bcf INTCON,PEIE	;zablokuj chwilowo przerwania od peryferiow
	retfie


;tablica znakow dla wyswietlacza
	org 150
maska_znak:	;'w' przed wywoalniem zawiera kod_znaku + licznik (czyli ktora kolumna)
	addwf PCL,f	;odczytaj z tablicy maske znaku
	dt H'7E',H'81',H'81',H'81',H'81',H'7E' ;maska dla '0' 
	dt H'00',H'80',H'FF',H'82',H'84',H'00' ;maska dla '1' 
	dt H'86',H'89',H'91',H'A1',H'C1',H'82' ;maska dla '2' 
	dt H'71',H'8B',H'85',H'81',H'81',H'41' ;maska dla '3' 
	dt H'20',H'FF',H'22',H'24',H'28',H'30' ;maska dla '4' 
	dt H'71',H'89',H'89',H'89',H'89',H'4F' ;maska dla '5' 
	dt H'70',H'89',H'89',H'89',H'8A',H'7C' ;maska dla '6' 
	dt H'07',H'09',H'F1',H'01',H'01',H'03' ;maska dla '7' 
	dt H'76',H'89',H'89',H'89',H'89',H'76' ;maska dla '8' 
	dt H'3E',H'51',H'91',H'91',H'91',H'0E' ;maska dla '9'
	dt H'80',H'80',H'80',H'80',H'80',H'80' ;maska dla 'overflow'
	;kolumny sa w odwrotnej kolejnosci (bo tak wyswietla napisana petla)

napis:
	addwf PCL,f	;odczytaj z tablicy maske znaku
	dt H'24',H'24',H'00'
	dt H'00',H'20',H'45',H'46',H'44',H'38',H'00'
	dt H'00',H'20',H'55',H'56',H'54',H'48',H'00'
	dt H'00',H'38',H'44',H'44',H'44',H'38',H'00'
	dt H'00',H'00',H'44',H'7F',H'51',H'00',H'00'
	dt H'00',H'3E',H'52',H'52',H'52',H'0C',H'00'
	dt H'00',H'18',H'54',H'54',H'54',H'38',H'00'
	dt H'00',H'00',H'40',H'7F',H'41',H'00',H'00'
	dt H'00',H'7F',H'48',H'44',H'44',H'38',H'00'
	dt H'00',H'38',H'44',H'44',H'44',H'38'

	end
