;Test_3_stan - program do  sprawdzania stanu linii "in"
;zapala led gdy linia in podlaczona do Vcc
;gasi led gdy linia in podlaczona do Vss
;miga led gdy linia in niepodlaczona


;wykorzystuje procedure test_in do sprawdzania stanu linii "in"
;podlaczenie linii przez rezystor 1 k do kondensatora 100 pF
;druga koncowka kondensatora podlaczona do masy
;stala czasowa obwodu RC = 0.1 us

;zwraca stan linii w rejestrze w
	;w = 0 linia in podczona do Vss
	;w = 1 linia in podczona do Vcc
	;w = 2 linia in nie podczona


#define in gpio, 0			;deklaracja 3 stanowej linii portu (GP0)		
#define	led	gpio, 2			;deklaracja led
 
 	;deklaracja typu procesora i formatu liczb

	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

	;konfiguracja procesora, fclk = 4 MHz
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_ON &_WDT_OFF
	
	org	h'00'				;adres poczatku programu
	goto	start			;skok do poczatku programu

	org	h'04'				;adres wektora przerwania
	goto	int				;skok do procedury obsugi przerwania


;==============================================================================	
start		;pocztek programu

	;wylacz komparator
	movlw	.7
	movwf	cmcon

	;wylacz A/C
	bsf		status, rp0		;bank1
	clrf	ansel
	bcf		status, rp0		;bank0

	clrf	gpio			;zeruj gpio - inicjalizacja portow

	;konfiguracja procesora
	
	bsf		status, rp0		;bank 1
	
	movlw	b'0001001'		;poza GP0 i GP3 wszystkie linie to wyjscia
	movwf	trisio

	movlw	b'11010111'		;t0cs =0, psa =0, preskaler = 256
	movwf	option_reg

	bcf		status, rp0		;bank 0
	
	clrf	tmr0			;zeruj licznik 0
	
	bcf		intcon, t0if	;zeruj flage przerwania z licznika 0	
	bsf		intcon, t0ie	;odblokuj przerwania z licznika 0	
	bsf		intcon, gie		;odblokuj przerwania

	goto	$		;petla gowna  oczekiwanie na porzerwanie z licznika 0


;==============================================================================		
int	;procedura obsugi przerwania wywoywana co 1/16 s

	bcf		intcon, t0if	;zeruj flage przerwania z licznika 0

	call	test_in			;sprawdz stan linii in, wynik sprawdzenia w rejestrze w

	addlw	0				;dodaj 0 do  w
	btfsc	status, z		;sprawdz czy w = 0
	goto	zgas 			;w=0, zgas led
	addlw	h'ff'			;dodaj h'ff' do  w
	btfsc	status, z		;sprawdz czy w = 0
	goto	zapal			;zapal led bo poprzednio w =1 (1+ h'ff' = h'100'
	goto	migaj			;migaj led bo poprzednio w =2

zapal		;zapala led
	bsf	led					;zapal led	
	retfie					;czekaj na kolejne sprawdzenie

zgas		;gasi led
	bcf	led					;zgas led	
	retfie					;czekaj na kolejne sprawdzenie

migaj		;neguje aktualny stan led
	movf	gpio, w			;przeczytaj stan portu gpio
	xorlw	b'00000100'		;zaneguj bit 2
	movwf	gpio			;wpisz do portu
	retfie					;czekaj na kolejne sprawdzenie


;ten sam efekt w procedurze migaj daje polecenie: comf gpio, f 
;ale oddziaywuje na wszystkie linie portu, a nie tylko na GP2

;migaj 	;neguje aktualny stan led
;	comf gpio, f			;zaneguj stan calego portu
;	retfie					;czekaj na kolejne sprawdzenie	


;==============================================================================	
;procedury
;==============================================================================	

;==============================================================================	
test_in		;sprawdza linie in, zwraca stan w rejestrze w
	;w = 0 linia in podlaczona do Vss
	;w = 1 linia in podlaczona do Vcc
	;w = 2 linia in nie podlaczona

	call 	set_out
	bcf		in				;wpisz 0
	call	set_in

	btfsc	in				;sprawdz czy in = 0
	retlw	 .1				;nie, w = 1, linia in podczona do Vcc
							;tak, sprawdzaj dalej
	call 	set_out
	bsf		in				;wpisz 1
	call 	set_in

	btfss	in				;sprawdz czy in = 1
	retlw 	.0				;nie, w=0, linia in podczona do Vss
	retlw 	.2				;tak, w=2, linia in nie podczona

set_in 		;ustaw in jako wejscie

	bsf		status, rp0		;bank 1
	bsf		in				;ustaw in jako wejcie
	bcf		status, rp0		;bank 0

	return

set_out		;ustaw in jako wyjcie

	bsf	status, rp0			;bank 1
	bcf	in					;ustaw in jako wyjcie
	bcf	status, rp0			;bank 0
	return


;==============================================================================	


	end		;koniec programu




