;wolt_4k woltomierz 4 kanalowy
;wysyla co 0.5 sek. niewyskalowane wyniki pomiaru z 4 kanalow przez rs
;zakres wynikow 0 - 1023
;moze wysylac sformatowane wyniki - procedura out_format


;	GP5 - linia out - (wyjscie TX RS232)
;	GP4	- kanal 3
;	GP3	- przycisk zerowania, wymagany rezystor podciagajacy do +Vcc (ok. 20 k)
;	GP2	- kanal 2
;	GP1	- kanal 1
;	GP0	- kanal 0

#define out 	gpio, 5		;deklaracja linii out (GP5)		


#define baud	.9600		;deklaracja szybkosci transmisji w bitach/sek
	

;===============================================================
;wartosci stalych ntb i ptb dla roznych szybkosci transmisji 
;najblizsza wartosc dla Fclk = 4.000 MHz
;uwaga - nalezy skalibrowac wewnetrzny oscylator
;ntb = (((fclk/4)/baud)-13)/3, fclk w Hz, baud w bitach/sek

	;TABELA ntb i ptb (wartosci dziesietne)

	; 2400 bit/sek - ntb = .134 lub .135	ptb = .66
	; 4800 bit/sek - ntb = .65 				ptb = .31
	; 9600 bit/sek - ntb = .30 lub .31		ptb = .14
	;19200 bit/sek - ntb = .13				ptb =  .5
	;38400 bit/sek - ntbt = .4				ptb =  .1


	if	baud == .2400		;szybkosc 2400 bit/sek
	#define	ntb	.134		;stala do odmierzania czasu trwania 1 bitu 
	endif

	if	baud == .4800		;szybkosc 4800 bit/sek
	#define	ntb	.65			;stala do odmierzania czasu trwania 1 bitu 
	endif

	if	baud == .9600		;szybkosc 9600 bit/sek
	#define	ntb	.30			;stala do odmierzania czasu trwania 1 bitu 
	endif

	if	baud == .19200		;szybkosc 19200 bit/sek
	#define	ntb	.13			;stala do odmierzania czasu trwania 1 bitu 
	endif

	if	baud == .38400		;szybkosc 38400 bit/sek
	#define	ntb	.4			;stala do odmierzania czasu trwania 1 bitu 
	endif

	ifndef	ntb
	error	"Zla szybkosc transmisji"
	endif


;===============================================================

	cblock	h'20'			;deklaracje adresow rejestrow

	tx_reg					;rejestr szeregowy nadajnika rs
	tx_cnt					;licznik bitow nadajnika rs
	del_reg					;licznik opoznienia nadajnika rs

	nr_kan					;numer kanalu
	ad_h, ad_l				;rejestry na wynik MSB i LSB

	endc

;=============================================================== 

 	;deklaracja typu procesora i formatu liczb

	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

	;konfiguracja procesora, fclk = 4 MHz
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_ON &_WDT_OFF

	errorlevel -302			;nie wyprowadzaj komunikatu nr 302
	
	org	h'00'				;adres poczatku programu
	goto	start			;skok do poczatku programu

	
start		;pocztek programu


	;konfiguracja procesora

	;wylacz komparator
	movlw	.7				;wylacz komparator
	movwf	cmcon			;cinv=1

	movlw	b'00100000'		;inicjalizacja linii portu
	movwf	gpio

	bsf	status, rp0			;bank 1

	;fabryczna kalibracja oscylatora

	call	h'3ff'			;fabryczna wartosc kalibracyjna -> w
	movwf	osccal			;w -> osccal

	movlw	b'00011111'		;gp0, gp1, gp2, gp4 - wejscia, gp5 - wyjscie
	movwf	trisio

	;konfiguracja przetwornika ac

	movlw	b'00111111'		;gp0, gp1, gp2, gp4 wejscia analogowe,wewn gen rc
	movwf	ansel 				;

	bcf		status, rp0		;bank 0

	;wybor justyfikacji, vref i zalaczenie przetw. a/c
	clrf	adcon0			;zeruj adcon0
	bsf		adcon0, adon	;zalacz przetwornik a/c
	bsf		adcon0, adfm	;justyfikacja w prawo

	;konfiguracja licznika 1
	movlw	b'00110000'		;preskaler = 8, wewn. zegar 
	movwf	t1con

	clrf	tmr1h			;zeruj rejestr tmr1h
	clrf	tmr1l			;zeruj rejestr tmr1l

	clrf	intcon			;zablokuj przerwania
	clrf	pir1			;zeruj flagi - t1if

	bsf		t1con, tmr1on	;zalacz timer 1


;===============================================================
loop		;petla glowna

	;odmierzanie czasu ok. 0.5 sek
	btfss	pir1, t1if		;sprawdz flage t1if
	goto	loop			;czekaj na przepelnienie timera 1
							;nastapilo przepelnienie timera 1 ( co 0.524 sek)
	bcf		pir1, t1if		;zeruj flage przepelnienia


	clrf	nr_kan			;ustaw kanal 0

pomiar		;petla do wykonywania pomiarow i wysylania wynikow

	call 	ac				;wykonaj pomiar

	call	wysw			;wyswietla wynik na terminalu

;	call	out_format		;wysyla sformatowany wynik

	incf	nr_kan, f		;zwieksz nr_kan
	movlw	.4
	subwf	nr_kan, w		;nr_kan - 4 -> w
	btfss 	status, z		;czy wszystkie kanaly (w=0)
	goto	pomiar			;nastepny pomiar


	;organizacja wyswietlania wynikow: 8 bajtow w linii oddzielonych spacjami
	;MSB LSB kan_0, MSB LSB kan_1, MSB LSB kan_2, MSB LSB kan_3 

	movlw	h'0A'			;nowa linia
	call	tx_out

	movlw	h'0D'			;przejdz na poczatek linii
	call	tx_out


	;inne procedury w petli wykonywane co 0.5 sek
	;...

	
	goto 	loop			;powrot do petli			

;================================================================================
;================================================================================
;procedury
;================================================================================
;================================================================================

;================================================================================
ac		;procedura konwersji ac

	;wybor kanalu 
	bcf		adcon0, chs0
	btfsc	nr_kan, 0		;ustal bit chs0
	bsf		adcon0, chs0
	
	bcf		adcon0, chs1
	btfsc	nr_kan, 1		;ustal bit chs1
	bsf		adcon0, chs1
	
	call	del_acq			;odczekaj czas akwizycji
	
	bsf		adcon0, go		;start konwersji 
	btfsc	adcon0, go		;czy koniec konwersji ?
	goto	$-1				;czekaj na koniec konwersji
	
	return					;wynik konw. w adresh i adresl
	
del_acq		;opoznienie na czas akwizycji 10 us
			;10 cykli maszynowych razem z wywolaniem i powrotem
	
	goto $+1				;opoznienie 2 cykle maszynowe
	goto $+1				;opoznienie 2 cykle maszynowe
	goto $+1				;opoznienie 2 cykle maszynowe
	
	return


;================================================================================
wysw	;wyswietla wyniki w kodzie ASCII - wersja 10 - 13 bitowa
		;wynik w adresh i adresl
		;numer kanalu w nr_kan

		;wyswietla nrumer kanalu spacje wynik dwie spacje

	movf	nr_kan, w
	andlw	b'00000011'		;ograniczenie 0, 1, 2, 3
	addlw	.48				;zamiana na ASCII
	call	tx_out			;wyslij

	movlw	.32				;kod spacji
	call	tx_out			;wyslij


	;wpisz wynik do rej. hbyte i lbyte
	movf	adresh, w
	movwf	hbyte

	bsf		status, rp0		;bank1	
	movf	adresl, w
	bcf		status, rp0		;bank0	
	movwf	lbyte

	call	bin2bcd			;zamien na bcd

;	;setki tys.
;	swapf	r2, w			;zamien polbajty r2 i wpisz do w
;	andlw	h'0F'			;tylko mlodszy bajt
;	addlw	.48				;zamiana na ASCII
;	call	tx_out			;wyslij
;	;dzies. tys.
;	movf	r2, w			;wpisz r2 do w
;	andlw	h'0F'			;tylko mlodszy bajt
;	addlw	.48				;zamiana na ASCII
;	call	tx_out			;wyslij

	;tysiace
	swapf	r1, w			;zamien polbajty r1 i wpisz do w
	andlw	h'0F'			;tylko mlodszy bajt
	addlw	.48				;zamiana na ASCII
	call	tx_out			;wyslij
	;setki
	movf	r1, w			;wpisz r1 do w
	andlw	h'0F'			;tylko mlodszy bajt
	addlw	.48				;zamiana na ASCII
	call	tx_out			;wyslij
	;dziesiatki
	swapf	r0, w			;zamien polbajty r0 i wpisz do w
	andlw	h'0F'			;tylko mlodszy bajt
	addlw	.48				;zamiana na ASCII
	call	tx_out			;wyslij
	;jednosci
	movf	r0, w			;wpisz r0 do w
	andlw	h'0F'			;tylko mlodszy bajt
	addlw	.48				;zamiana na ASCII
	call	tx_out			;wyslij

	;dwie spacje odstepu
	movlw	.32				;kod spacji
	call	tx_out			;wyslij
	movlw	.32				;kod spacji
	call	tx_out			;wyslij


	return


;================================================================================
tx_out		;wysyla bit startu, 8 bitow danych i bit stopu

	movwf	tx_reg			;wpisz dane do rejestru tx_reg

	movlw	.9
	movwf	tx_cnt			;licznik bitow (1+8)

	bcf	status, c			;wpisz bit startu

tx_loop		;petla do nadwania bitow
	
	btfss	status, c		;sprawdz c
	bcf		out				;c=0, zeruj out
	btfsc	status, c		;sprawdz c
	bsf		out				;c=1, ustaw out

	call	del_ntb			;opoznienie na czas 1 bitu
	
	rrf		tx_reg, f		;przesun do c kolejny bit

	decfsz	tx_cnt, f		;sprawdz czy nadano wszystkie bity
	goto	tx_loop			;nie, nadawaj kolejny bit

	bsf		status, c		;wpisz bit stopu

	btfss	status, c		;sprawdz c
	bcf		out				;c=0, zeruj out
	btfsc	status, c		;sprawdz c
	bsf		out				;c=1, ustaw out

	goto	$+1				;opoznienie wyrownawcze
	goto	$+1				;opoznienie wyrownawcze
	call	del_ntb			;opoznienie na czas 1 bitu, nadaje pierwszy bit stopu

;	drugi bit stopu
;	goto	$+1				;opoznienie wyrownawcze
;	goto	$+1				;opoznienie wyrownawcze
;	goto	$+1				;opoznienie wyrownawcze
;	call	del_ntb			;opoznienie na czas 1 bitu, nadaje drugi bit stopu

	return

del_ntb		;odmierza opoznienie na czas trwania 1 bitu

	movlw	ntb				;stala do odmierzania czasu 1 bitu	
	movwf	del_reg			;wpisz wartosc poczatkowa do licznika 

	decfsz	del_reg, f		;sprawdz czy del_reg =0 (petla do odliczania opoznienia)
	goto	$-1				;nie, czekaj dalej
	
	return


;================================================================================
;konwersja bin na bcd, wersja 16 bitowa

	;deklaracje rejestrow
	 cblock  
     	r0, r1, r2		    ;liczba dziesietna spakowana (6 cyfr)
     	lbyte, hbyte		;liczba binarna (2 bajty)
	 	cb0, cb1			;liczniki pomocnicze
     endc    

	;r0	dziesiatki 	jednosci
	;r1	tysiace		setki
	;r2	setki tys.	dzies. tys

	;lbyte	mlodszy bajt
	;hbyte	starszy bajt
	
bin2bcd movlw   .16			;liczba bitow
        movwf   cb0			;wpisz do licznika bitow
        clrf    r0
        clrf    r1
        clrf    r2

bin2bcd1 
		movlw   r0
        movwf   fsr			;wskaznik na r0
		movlw	.3			;liczba bajtow wyniku
		movwf	cb1			;wpisz do licznika

bin2bcd2 		;korekta dziesietna
		movlw   h'33'		
        addwf   indf, f		;dodaj h'33'
        btfsc   indf, 3		;sprawdz czy dolny polbajt > 7
		andlw	h'F0'		;tak, zeruj dolny polbajt w
        btfsc   indf, 7		;sprawdz czy gorny polbajt > 7
		andlw	h'0F'		;tak, zeruj gorny polbajt w
        subwf   indf, f		;wynik =< 7, odejmij poprawke
        incf    fsr, f		;nastepny bajt danych
		decfsz	cb1, f		;nastepne bajty wyniku
        goto    bin2bcd2

		;przesun kolejny bit
		rlf     lbyte, f
        rlf     hbyte, f
        rlf     r0,f
        rlf     r1,f
        rlf     r2,f

        decfsz  cb0, f		;czy wszystkie bity
        goto    bin2bcd1

        retlw   0


;===============================================================================
out_format	;wysyla sformatowany wynik oddzielony spacjami

	call	format			;formatuj wynik

	movf	ad_h, w			;wpisz do w starszy bajt
	call 	tx_out			;wyslij starszy bajt
	movf	ad_l, w			;wpisz do w mlodszy bajt
	call 	tx_out			;wyslij mlodszy bajt

	movlw	h'20'			;kod spacji
	call	tx_out			;wyslij spacje

	return


;===============================================================================
format		;formatuj wynik, k1, k0 - nr kanalu, b9...b0 - wynik pomiaru

			;ad_h = MSB 1, k1, k0,  0,  0, b9, b8, b7
			;ad_l = LSB 0, b6, b5, b4, b3, b2, b1, b0

	bsf		status, rp0		;bank1
	movf	adresl, w		;adresl -> w
	bcf		status, rp0		;bank0
	movwf	ad_l			;w -> ad_l
	movf	adresh, w		;adresh -> w
	movwf	ad_h			;w -> ad_h

	rlf		ad_l, w			;przesun 7 bit do c
	rlf		ad_h, f			;przesun c do 0 bitu ad_h

	bcf		ad_l, 7			;zeruj 7 bit w ad_l
	bsf		ad_h, 7			;ustaw 7 bit w ad_h

	btfsc	nr_kan, 0		;sprawdz 0 bit w nr_kan
	bsf		ad_h, 5			;ustaw 5 bit w ad_h
	btfsc	nr_kan, 1		;sprawdz 1 bit w nr_kan
	bsf		ad_h, 6			;ustaw 6 bit w ad_h

	return


;================================================================================

	
	end


